
;dTest Version 1.0 - DednDave, 9-2011

;#############################################################################################################

;display buffer default dimensions

BUFFER_COLUMNS           EQU 80               ;display buffer columns
BUFFER_ROWS              EQU 64               ;display buffer rows

;*************************************************************************************************************

;conditional assembly controls - any non-zero value evaluates to true (selection enabled)

;-------------------------

;build model selection - select one and only one - hard error for invalid combinations

dTest_BUILD_DUALMODE     EQU 1

;-------------------------

;internal test modes - warning error only if both selected

dTest_TESTMODE_STATIC    EQU 0
dTest_TESTMODE_DYNAMIC   EQU 0

;#############################################################################################################

;build configuration validation

;-------------------------

;display buffer size limits

MAX_DISPLAY_COLUMNS      EQU 256
MAX_DISPLAY_ROWS         EQU 1024

;-------------------------

;validate default display buffer dimensions

dTest_BUILD_PRESENTATION EQU 0
dTest_BUILD_STANDALONE   EQU 0

INVALID_SELECTION=(BUFFER_COLUMNS LE 0) or (BUFFER_COLUMNS GT MAX_DISPLAY_COLUMNS)
INVALID_SELECTION=INVALID_SELECTION or (BUFFER_ROWS LE 0) or (BUFFER_ROWS GT MAX_DISPLAY_ROWS)
IF INVALID_SELECTION
ECHO ERROR: Invalid Display Buffer Dimension(s).
ENDIF
.ERRNZ INVALID_SELECTION

;-------------------------

;validate build selections

INVALID_SELECTION=(dTest_BUILD_PRESENTATION EQ 0)+(dTest_BUILD_STANDALONE EQ 0)+(dTest_BUILD_DUALMODE EQ 0)+2
IF INVALID_SELECTION
ECHO ERROR: Invalid Build Selection: Select one and only one build model.
ENDIF
.ERRNZ INVALID_SELECTION

;-------------------------

;validate test mode selections

INVALID_SELECTION=(dTest_TESTMODE_STATIC NE 0) and (dTest_TESTMODE_DYNAMIC NE 0)
IF INVALID_SELECTION
ECHO WARNING: Both Static and Dynamic Test Modes Enabled.
ENDIF

;-------------------------

;build WM_COPYDATA combination

dTest_BUILD_COPYDATA     EQU dTest_BUILD_PRESENTATION or dTest_BUILD_DUALMODE

;#############################################################################################################

        INCLUDE dTest.inc
        INCLUDE WmFmt.inc

;#############################################################################################################

;misc default value equates

;-------------------------

BACK_COLOR          EQU MyBlack_0        ;default background color
FORE_COLOR          EQU MyAmber_6        ;default foreground color
STATUS_BAR          EQU MF_CHECKED       ;default status bar state, MF_UNCHECKED = off, MF_CHECKED = on

;-------------------------

;These values determine the window size the first time the application is run without a dTest.bin file.
;Once it has been run, the user-selected window size is maintained in that file.
;The width is based on the default character width (8) and buffer columns.

WINDOW_WIDTH_ADDEND EQU 27               ;default window added width in pixels
WINDOW_HEIGHT       EQU 462              ;default window height in pixels

;*************************************************************************************************************

;dynamic test mode constants - ignored if dynamic test not selected

thrd_mode   EQU DMODE_FULL_AUTO ;DMODE_SEMI_AUTO, DMODE_FULL_AUTO, DMODE_MANUAL
thrd_time1  EQU 62
thrd_time2  EQU 1000

;#############################################################################################################

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;test prototypes

DynamicTest PROTO

;test equates

thrd_ctrl   EQU 0


        .DATA
        ALIGN    4

;test data

TxtBuf      db BUFFER_COLUMNS dup(0),13,10,0
teststr     db '123456789 ',0
thrdend     db -1
thrdended   db -1
testcnt     dd 8

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

        .DATA
        ALIGN    4

cBuffQty        equ 256
cBuffEnable     dd 0
cBuffHead       dd cBuff
cBuffTail       dd cBuff
cBuff           dd 4*cBuffQty dup(?)   ;in uninitialized data section
cBuffEnd        equ $

FeCount          dd FeList
wrUpdate         dd wrUpd

WheelVect        dd WvNrm,WvShf,WvCtl,WhNrm,WhShf
WheelPtrs        dd ShftVrtState,CtrlVrtState,HrzState,ShftHrzState

CmdVectUsr       dd dCC_Acknowledge,dCC_Continue,dCC_Flush
CmdVectPma       dd dCC_Acknowledge,dCC_Continue,dCC_Flush,dCP_Print

ams AppModeStruct <0,dCU_Base,dCU_MaxCmd,CmdVectUsr,AppNameUsr,dCP_Base,dCP_MaxCmd,CmdVectPma,AppNamePma>
; hRcvr         dd ?
; nBaseCmd      dd dCU_Base          ;dCU_Base or dCP_Base (equates)
; nMaxCmd       dd dCU_MaxCmd        ;dCU_MaxCmd or dCP_MaxCmd (equates)
; lpCmdVect     dd CmdVectUsr        ;command dispatch vector table
; AppNamePtr    dd AppNameUsr        ;pointer to AppName string
; nPmaBaseCmd   dd dCP_Base
; nPmaMaxCmd    dd dCP_MaxCmd
; lpPmaCmdVect  dd CmdVectPma
; PmaAppNamePtr dd AppNamePma

vs ViewSettings <0,WINDOW_HEIGHT,80Ch,BACK_COLOR,FORE_COLOR>
; WndWidth         dd 0                 ;default filled in at init
; WndHeight        dd WINDOW_HEIGHT
; DefaultTextSize  dd 80Ch              ;default = 8x12
; BackColor        dd BACK_COLOR        ;background color
; ForeColor        dd FORE_COLOR        ;foreground color

CustomColors ColorStruct <MyBlack_0,MyBlue_1,MyGreen_2,MyCyan_3,\
                          MyRed_4,MyMagenta_5,MyAmber_6,MyLtGrey_7,\
                          MyGrey_8,MyLtBlue_9,MyLtGreen_A,MyLtCyan_B,\
                          MyLtRed_C,MyLtMagenta_D,MyYellow_E,MyWhite_F>

WinCreateTable   dd WS_CHILD or WS_VISIBLE or SBARS_SIZEGRIP,StatusClass
                 dd WS_CHILD or SBS_HORZ,ScrollClass
                 dd WS_CHILD or SBS_VERT,ScrollClass
                 dd WS_CHILD or SBS_SIZEBOX,ScrollClass
                 dd WS_CHILD or SBS_SIZEGRIP,ScrollClass
                 dd WS_CHILD or WS_VISIBLE,TxtClass

;main menu table - item qty, each item: (lpNewItem,uIDNewItem,uFlags)

MenuTable        dd 3                                                  ;'File' menu
                 dd szSaveAs,IDM_FILE_SAVEAS,MF_GRAYED                 ;'Save As...'
                 dd NULL,NULL,MF_SEPARATOR                             ;MFT_SEPARATOR
                 dd szExit,IDM_FILE_EXIT,MF_STRING                     ;'Exit'
                 dd szFileMenu                                         ;'File'
                 dd 2                                                  ;'Edit' menu
                 dd szCopyAll,IDM_EDIT_COPYALL,MF_GRAYED               ;'Copy All'
                 dd szCopyForum,IDM_EDIT_COPYFORUM,MF_GRAYED           ;'Copy Forum'
                 dd szEditMenu                                         ;'Edit'
                 dd 5                                                  ;'View' menu
                 dd szForeColor,IDM_FORE_COLOR,MF_STRING               ;'Foreground Color'
                 dd szBackColor,IDM_BACK_COLOR,MF_STRING               ;'Background Color'
                 dd NULL,NULL,MF_SEPARATOR                             ;MFT_SEPARATOR
                 dd NULL,NULL,MF_SEPARATOR                             ;MFT_SEPARATOR
                 dd szStatusBar,IDM_VIEW_STATUSBAR
StbState         dd STATUS_BAR                                         ;'Status Bar'
                 dd szViewMenu                                         ;'View'
                 dd 3                                                  ;'Help' menu
                 dd szHelpMenu,IDM_HELP_HELP,MF_STRING                 ;'Help'
                 dd NULL,NULL,MF_SEPARATOR                             ;MFT_SEPARATOR
                 dd szAbout,IDM_HELP_ABOUT,MF_STRING                   ;'About'
                 dd szHelpMenu                                         ;'Help'
                 dd 2                                                  ;'Reset Colors' submenu
                 dd szCustomFore,IDM_VIEW_RESETFORE,MF_STRING          ;'Custom Foreground Colors'
                 dd szCustomBack,IDM_VIEW_RESETBACK,MF_STRING          ;'Custom Background Colors'
                 dd szReset                                            ;'Reset Colors'
                 dd 5                                                  ;'Mouse Wheel' submenu
                 dd szShftVert,IDM_VIEW_MWSHFTVRT
ShftVrtState     dd MF_CHECKED                                         ;'Shft Vert'
                 dd szCtrlVert,IDM_VIEW_MWCTRLVRT
CtrlVrtState     dd MF_CHECKED                                         ;'Ctrl Vert'
                 dd NULL,NULL,MF_SEPARATOR                             ;MFT_SEPARATOR
                 dd szHorz,IDM_VIEW_MWHRZ
HrzState         dd MF_CHECKED                                         ;'Horz'
                 dd szShftHorz,IDM_VIEW_MWSHFTHRZ
ShftHrzState     dd MF_CHECKED                                         ;'Shft Horz'
                 dd szWheel                                            ;'Mouse Wheel'

szFileMenu       db 'File',0
szEditMenu       db 'Edit',0
szViewMenu       db 'View',0
szHelpMenu       db 'Help',0
szSaveAs         db 'Save As...',0
szExit           db 'Exit',0
szCopyAll        db 'Copy All',0
szCopyForum      db 'Copy Forum',0
szForeColor      db 'Foreground Color',0
szBackColor      db 'Background Color',0
szStatusBar      db 'Status Bar',0
szAbout          db 'About',0
szTextSize       db 'Text Size',0
szCustomFore     db 'Custom Foreground Colors',0
szCustomBack     db 'Custom Background Colors',0
szReset          db 'Reset Colors',0
szVert           db 'Vert',0
szShftVert       db 'Shft Vert',0
szCtrlVert       db 'Ctrl Vert',0
szHorz           db 'Horizontal',0
szShftHorz       db 'Shft Horz',0
szWheel          db 'Mouse Wheel',0

WndClass         db 'dTestClass',0
TxtClass         db 'dTestText',0
ScrollClass      db 'ScrollBar',0
StatusClass      db 'msctls_statusbar32',0
AppNameUsr       db 'dTest User Mode',0
AppNamePma       db 'dTest Presentation Mode',0
AboutText        db 'dTest',10
                 db 'Copyright ',169,' 2011 David R. Sheldon'
NullStr          db 0
FileTypeStrs     db 'Text Files',0,'*.txt',0,'All Files',0,'*.*',0,0
IccErrText       db 'InitCommonControls Failed',0
AllocErrText     db 'Heap Allocation Error',0
szExists         db 'File Already Exists',0
szAppend         db 'Append',0
szOverwrite      db 'Overwrite',0
szVerify         db 'Are You sure ?',0
szYes            db 'Yes',0
FileErrTitle     db 'Error Writing File',0
FileErrText      db 'Select a different file name and/or location and try again',0
CbErrTitle       db 'Error Copying to Clipboard',0
CbErrText        db 'Close any programs that may be using the clipboard and try again',0
HelpText         db 'Help is on the way! ;)',0
szDateFormat     db "d'-'MMM'-'yyyy",0

PmaErrText       db 'Unable to Open Presentation Manager Application',0

;*************************************************************************************************************

        .DATA?
        ALIGN    4

;-------------------------
;BEGIN PRESET VALUES

cg CoordinateGroup <>
; h         CoordInfo <>
;   s        SCROLLINFO <>
;     cbSize           dd ?  ;initialized to sizeof SCROLLINFO = 28
;     fMask            dd ?  ;initialized to SIF_RANGE or SIF_PAGE or SIF_POS = 7
;     nMin             dd ?  ;initialized to 0
;     nMax             dd ?  ;initialized to 0
;     nPage            dd ?  ;initialized to 0
;     nPos             dd ?  ;initialized to 0
;     nTrackPos        dd ?  ;initialized to 0
;   CellsUsed        dd ?    ;initialized to 1
;   CellSize         dd ?    ;initialized to 8
;   Mult             dd ?    ;initialized to 0
;   Shft             dd ?    ;initialized to 0
;   CurPos           dd ?    ;initialized to 0
;   NewPos           dd ?    ;initialized to 0
;   BarSize          dd ?    ;initialized to 0
;   WheelDiv         dd ?    ;initialized to 3
;   WheelCnt         dd ?    ;initialized to 0
; v         CoordInfo <>
;   s        SCROLLINFO <>
;     cbSize           dd ?  ;initialized to sizeof SCROLLINFO = 28
;     fMask            dd ?  ;initialized to SIF_RANGE or SIF_PAGE or SIF_POS = 7
;     nMin             dd ?  ;initialized to 0
;     nMax             dd ?  ;initialized to 0
;     nPage            dd ?  ;initialized to 0
;     nPos             dd ?  ;initialized to 0
;     nTrackPos        dd ?  ;initialized to 0
;   CellsUsed        dd ?    ;initialized to 1
;   CellSize         dd ?    ;initialized to 12
;   Mult             dd ?    ;initialized to 0
;   Shft             dd ?    ;initialized to 0
;   CurPos           dd ?    ;initialized to 0
;   NewPos           dd ?    ;initialized to 0
;   BarSize          dd ?    ;initialized to 0
;   WheelDiv         dd ?    ;initialized to 3
;   WheelCnt         dd ?    ;initialized to 0

lf LOGFONT <>
; lfHeight         dd ?      ;initialized to 0
; lfWidth          dd ?      ;initialized to 0
; lfEscapement     dd ?      ;initialized to 0
; lfOrientation    dd ?      ;initialized to 0
; lfWeight         dd ?      ;initialized to 0
; lfItalic         db ?      ;initialized to 0
; lfUnderline      db ?      ;initialized to 0
; lfStrikeOut      db ?      ;initialized to 0
; lfCharSet        db ?      ;initialized to 0
; lfOutPrecision   db ?      ;initialized to 0
; lfClipPrecision  db ?      ;initialized to 0
; lfQuality        db ?      ;initialized to 0
; lfPitchAndFamily db ?      ;initialized to 0
; lfFaceName       db LF_FACESIZE dup(?)  ;LF_FACESIZE = 32, initialized to 0

rvs ResetValuesStruct <>
; LocCntX            dd ?    ;initialized to 0
; LocCntY            dd ?    ;initialized to 0
; SequenceX          dd ?    ;initialized to 0
; SequenceR          dd ?    ;initialized to 0
; MinFlag            dd ?    ;initialized to 0
; WrFlag             db ?    ;initialized to 0
; WheelKeys          db ?    ;initialized to 0
; dUpdateMode        db ?    ;0=manual, 1=semi-auto (update on each newline), 3=full-auto (newline or exit dTxtOut)
; dUpdateFlags       db ?    ;initialized to 0
; sUpdateEnable      db ?    ;initialized to 0
; BufDisable         db ?    ;initialized to 0
; FSSemaphore        db ?    ;file save semaphore, initialized to 0
; CCSemaphore        db ?    ;color chooser semaphore, initialized to 0
; HHSemaphore        db ?    ;help-help semaphore, initialized to 0
; HASemaphore        db ?    ;help-about semaphore, initialized to 0
; rPSemaphore        db ?    ;initialized to 0
;                    db ?    ;alignment byte, initialized to 0

pvs PresetValuesStruct <>
; TxtWidth           dd ?    ;initialized to -1
; TxtHeight          dd ?    ;initialized to -1
; BsgPosX            dd ?    ;initialized to -1
; BsgPosY            dd ?    ;initialized to -1
; BngPosX            dd ?    ;initialized to -1
; BngPosY            dd ?    ;initialized to -1
; MaxFlag            dd ?    ;initialized to -1
; SizeID             dd ?    ;initialized to -1
; WinStates          dd ?    ;initialized to 1 = CID_STATUSBAR and STATE_MASK
; SeqFlush           dd ?    ;initialized to 1 (non-zero count)

;END PRESET VALUES
;-------------------------

phs ProcessHandles <>
; hInstance      HANDLE ?
; hIcon          HANDLE ?
; hCursor        HANDLE ?

lpCmndLineFull   dd ?
lpCmndLine       dd ?
hFont            dd ?
hMenu            dd ?
hEditMenu        dd ?
hWin             dd ?
hMbHook          dd ?

StbHeight        dd ?
StbPosY          dd ?
StbWidth         dd ?
WrkWidth         dd ?
WrkHeight        dd ?
CCMode           dd ?
SaveAsFlag       dd ?

cdTimeCnt        dd ?

dbi DisplayBufferInfo <>
; BufferColumns     dd ?
; BufferRows        dd ?
; hHeap             dd ?
; hDisplayBuf       dd ?
; lpDisplayBuf      dd ?
; RowLength         dd ?    ;(BufferColumns+5) AND 0FFFFFFFCh
; BufCalc1          dd ?    ;RowLength/4
; BufCalc2          dd ?    ;BufferRows-1
; BufCalc3          dd ?    ;RowLength*(BufferRows-1)/4
; BufCalc4          dd ?    ;RowLength*BufferRows/4
; SecondRowAddr     dd ?    ;address of second buffer row
; LastRowAddr       dd ?    ;address of last buffer row

chs ControlHandles <>
; hStatus        HWND ? ;ID = 1001h
; hHScroll       HWND ? ;ID = 1002h
; hVScroll       HWND ? ;ID = 1004h
; hSizeBoxNG     HWND ? ;ID = 1008h
; hSizeBoxG      HWND ? ;ID = 1010h
; hTxt           HWND ? ;ID = 1020h

cc ColorGroup <>
; BackColors ColorStruct <>
; ForeColors ColorStruct <>

wr RECT <>
; left             dd ?
; top              dd ?
; right            dd ?
; bottom           dd ?

ssf SavedSettingsFile <>
; szMarker         db 10 dup(?) ;'dTest.bin',0
; wFileSize        dw ?         ;120
; wWindowWidth     dw ?
; wWindowHeight    dw ?
; wFlagsTextSize   dw ?
; rgbBackColor     db 3 dup(?)
; rgbForeColor     db 3 dup(?)
; rgbCustomBack    db 48 dup(?)
; rgbCustomFore    db 48 dup(?)

FeList           dw FELISTLENGTH dup(?)

MbHookFlag       db ?

;#############################################################################################################

        .CODE

;*************************************************************************************************************

MsgLoop PROC

;MSG STRUCT
; hwnd             dd ?
; message          dd ?
; wParam           dd ?
; lParam           dd ?
; time             dd ?
; pt               POINT <>
;   x                dw ?
;   y                dw ?

mLoop0: INVOKE  TranslateMessage,ebp
        INVOKE  DispatchMessage,ebp

mLoop:: INVOKE  GetMessage,ebp,edi,edi,edi
        inc     eax                                ;exit only
        shr     eax,1                              ;if 0 or -1
        jnz     mLoop0

;----------------------

;program terminate

        INVOKE  HFree,dbi.hDisplayBuf
        pop     eax                                ;EAX = MSG.hWnd, [ESP] = MSG.message
        JMP     ExitProcess                        ;[ESP+4] = MSG.wParam

MsgLoop ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

pCalc   PROC    p7:UINT,p6:UINT,p5:UINT,p4:UINT,p3:UINT,p2:UINT,p1:UINT

;paint calculation routine
;this routine is called once for vertical calculations and once for horizontal
;
;parameters are not discarded at exit
;all registers may be used except EBP, which must be preserved
;
;retained input values            vertical                 horizontal
;
;p1 [EBP+32] buffer start         cg.v.CurPos/cg.v.NewPos  cg.h.CurPos/cg.h.NewPos
;p2 [EBP+28] buffer size          cg.v.CellsUsed           cg.h.CellsUsed
;p3 [EBP+24] cell size (divisor)  cg.v.CellSize            cg.h.CellSize
;
;discardable input values
;
;p4 [EBP+20] M2D shift            cg.v.Shft                cg.h.Shft
;p5 [EBP+16] M2D multiplier       cg.v.Mult                cg.h.Mult
;p6 [EBP+12] stop pixel           ps.rcPaint.bottom        ps.rcPaint.right
;p7 [EBP+8]  start pixel          ps.rcPaint.top           ps.rcPaint.left
;
;returned values
;
;p4 [EBP+20] adjusted start pixel
;p5 [EBP+16] start buffer char
;p6 [EBP+12] text char count

        push    ebp
        mov     ebp,esp
        mov     eax,[ebp+12] ;stop pixel
        mov     edi,[ebp+16] ;M2D multiplier
        sub     eax,2
        mov     ecx,[ebp+20] ;M2D shift
        jbe     pCalc3

        push    eax          ;dividend
        mul     edi
        mov     eax,[ebp+8]  ;start pixel
        shr     edx,cl
        sub     eax,1
        mov     esi,edx      ;quotient
        ja      pCalc0

        xor     eax,eax
        xor     ebx,ebx
        mov     edi,eax
        jmp short pCalc1

pCalc0: mov     ebx,eax      ;dividend
        mul     edi
        shr     edx,cl
        mov     eax,[ebp+24] ;cell size (divisor)
        mov     edi,edx      ;quotient
        mul     edx

pCalc1: pop     ecx
        inc     esi
        cmp     ecx,ebx
        jb      pCalc3

        sub     esi,edi
        jbe     pCalc3

        mov     ebx,[ebp+28] ;buffer size
        inc     eax
        add     edi,[ebp+32] ;buffer start
        mov     [ebp+20],eax ;adjusted start pixel
        sub     ebx,edi
        jbe     pCalc3

        cmp     esi,ebx
        jbe     pCalc2

        mov     esi,ebx

pCalc2: mov     [ebp+16],edi ;start buffer char
        mov     [ebp+12],esi ;text char count
        or      esi,esi      ;zero flag
        pop     ebp
        ret

pCalc3: pop     ebp
        cmp     esi,esi      ;zero flag = 1
        ret

pCalc   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

TxtProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;WndProc routine for the text window

        mov     ecx,[esp+8]                                    ;uMsg

cmp byte ptr cBuffEnable,0
jz around
cmp ecx,WM_COPYDATA
jz around
push esi
lea esi,[esp+8] ;call with ESI = address of WndProc hWnd parm on stack

include WmFilter.inc

pop esi
around:

        cmp     ecx,WM_PAINT
        jnz     TxtPr0

;------------------------------------------------------------------------------

;WM_PAINT

;PAINTSTRUCT <>        ;(64 bytes)
; hdc         dd ?     ;[EBP]
; fErase      dd ?
; rcPaint     RECT <>
;   left        dd ?   ;[EBP+8]
;   top         dd ?   ;[EBP+12]
;   right       dd ?   ;[EBP+16]
;   bottom      dd ?   ;[EBP+20]
; fRestore    dd ?
; fIncUpdate  dd ?
; rgbReserved db 32 dup(?)

        push    ebp
        push    ebx
        push    esi
        push    edi
        sub     esp,sizeof PAINTSTRUCT
        mov     ebp,esp
        INVOKE  BeginPaint,[ebp+84],esp
        mov     eax,cg.h.NewPos
        xor     ecx,ecx
        mov     edx,cg.v.NewPos
        cmp     eax,cg.h.CurPos
        jnz     Paint0

        cmp     edx,cg.v.CurPos
        jz      Paint1

Paint0: mov     edi,cg.v.s.nPage
        mov     cg.h.CurPos,eax
        mov     esi,ecx
        mov     cg.v.CurPos,edx
        push    edi
        push    cg.h.s.nPage
        push    esi
        push    ecx
        jmp short Paint2

Paint1: mov    edi,[ebp+20]                                    ;ps.rcPaint.bottom
        mov    esi,[ebp+12]                                    ;ps.rcPaint.top
        push   edi
        push dword ptr [ebp+16]                                ;ps.rcPaint.right
        push   esi
        push dword ptr [ebp+8]                                 ;ps.rcPaint.left

Paint2: INVOKE  pCalc,esi,edi,cg.v.Mult,cg.v.Shft,cg.v.CellSize,cg.v.CellsUsed,edx
        jz      Paint7

        INVOKE  pCalc,[ebp-16],[ebp-8],cg.h.Mult,cg.h.Shft,cg.h.CellSize,cg.h.CellsUsed,cg.h.CurPos
        jz      Paint7

        mov     eax,[ebp]                                      ;EAX = hdc
        push    hFont                                          ;SelectObject1:new font handle
        push    eax                                            ;SelectObject1:hdc
        push    TRANSPARENT                                    ;SetBkMode:iBkMode
        push    eax                                            ;SetBkMode:hdc
        push    vs.BackColor                                   ;SetBkColor:crColor
        push    eax                                            ;SetBkColor:hdc
        INVOKE  SetTextColor,eax,vs.ForeColor
        CALL    SetBkColor
        CALL    SetBkMode
        CALL    SelectObject
        xchg    eax,ecx
        mov     ebx,[ebp-40]                                   ;text row count
        mov     eax,dbi.RowLength
        mov     edi,[ebp-32]                                   ;vert adjusted start pixel
        push    eax                                            ;[EBP-76] = dbi.RowLength
        push    ecx                                            ;[EBP-80] = SelectObject2:old font handle

;-------

;[EBP+84] = hWnd = chs.hTxt
;[EBP+20] = ps.rcPaint.bottom     paint structure
;[EBP+16] = ps.rcPaint.right            v v
;[EBP+12] = ps.rcPaint.top
; [EBP+8] = ps.rcPaint.left
; [EBP+4] = ps.fErase                   ^ ^
;   [EBP] = ps.hdc                paint structure, starting with hdc
; [EBP-4] = clip_rect.bottom
; [EBP-8] = clip_rect.right
;[EBP-12] = clip_rect.top
;[EBP-16] = clip_rect.left
;[EBP-20] = cg.v.CurPos/cg.v.NewPos
;[EBP-24] = cg.v.CellsUsed
;[EBP-28] = cg.v.CellSize
;[EBP-32] = vert adjusted start pixel
;[EBP-36] = vert start buffer row
;[EBP-40] = text row count
;[EBP-44] = clip_rect.top
;[EBP-48] = cg.h.CurPos/cg.h.NewPos
;[EBP-52] = cg.h.CellsUsed
;[EBP-56] = cg.h.CellSize
;[EBP-60] = horz adjusted start pixel
;[EBP-64] = horz start buffer char
;[EBP-68] = text column count
;[EBP-72] = clip_rect.left
;[EBP-76] = dbi.RowLength
;[EBP-80] = old font handle

;-------

        mul dword ptr [ebp-36]                                 ;vert start buffer row
        inc     ebx
        add     eax,dbi.lpDisplayBuf
        mov     edx,[ebp-64]                                   ;horz start buffer char
        xchg    eax,esi
        mov     ecx,[ebp-68]                                   ;text column count
        jmp short Paint6

;-------

;EBX = text row count+1
;ECX = text column count
;EDX = horz start buffer char
;ESI = buffer row base pointer
;EDI = vert adjusted start pixel

Paint3: movzx   eax,word ptr [esi]
        push    ecx
        sub     eax,edx
        jbe     Paint5

        cmp     eax,ecx
        push    edx
        jbe     Paint4

        xchg    eax,ecx

Paint4: lea     edx,[esi+edx+2]
        lea     ecx,[ebp-16]                                   ;clip_rect
        INVOKE  ExtTextOut,[ebp],[ebp-60],edi,ETO_CLIPPED,ecx,edx,eax,NULL
        pop     edx

Paint5: add     esi,[ebp-76]                                   ;dbi.RowLength
        pop     ecx
        add     edi,[ebp-28]                                   ;cg.v.CellSize

Paint6: sub     ebx,1
        jnz     Paint3

;-------

        push dword ptr [ebp]                                   ;SelectObject2:hdc
        CALL    SelectObject

Paint7: mov     esp,ebp
        INVOKE  EndPaint,[ebp+84],ebp
        add     esp,sizeof PAINTSTRUCT
        pop     edi
        pop     esi
        pop     ebx
        pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

TxtPr0: cmp     ecx,WM_RBUTTONUP
        JNZ     DefWindowProc

;----------------------

;WM_RBUTTONUP

        push    ebp
        mov     ebp,esp
        xor     eax,eax
        mov     edx,[ebp+8]           ;hWnd
        push    eax                                                               ;TrackPopupMenu:prcRect
        movzx   ecx,word ptr [ebp+22] ;lParam high word
        push    edx                                                               ;TrackPopupMenu:hWnd
        push    eax                                                               ;TrackPopupMenu:nReserved
        movzx   eax,word ptr [ebp+20] ;lParam low word
        push    ecx                                                               ;TrackPopupMenu:y
        push    eax                                                               ;TrackPopupMenu:x
        INVOKE  ClientToScreen,edx,esp
        push    TPM_RETURNCMD or TPM_LEFTALIGN or TPM_TOPALIGN or TPM_NOANIMATION ;TrackPopupMenu:uFlags
        push    hEditMenu                                                         ;TrackPopupMenu:hMenu
        CALL    TrackPopupMenu
        jmp     TxPop                 ;in WndProc

TxtProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;WndProc routine for the main window

;------------------------------------------------------------------------------

        mov     ecx,[esp+8]                                  ;uMsg

cmp byte ptr cBuffEnable,0
jz around
cmp ecx,WM_COPYDATA
jz around
push esi
lea esi,[esp+8] ;call with ESI = address of WndProc hWnd parm on stack

include WmFilter.inc

pop esi
around:

        cmp     ecx,WM_PAINT                                 ;0Fh
        JZ      DefWindowProc

        cmp     ecx,WM_SETCURSOR                             ;20h
        JZ      DefWindowProc

        cmp     ecx,WM_NCHITTEST                             ;84h
        JZ      DefWindowProc

        cmp     ecx,WM_CTLCOLORSCROLLBAR                     ;137h
        JZ      DefWindowProc

        cmp     ecx,WM_NCMOUSEMOVE                           ;0A0h
        JZ      DefWindowProc

        cmp     ecx,WM_ENTERIDLE                             ;121h
        JZ      DefWindowProc

        cmp     ecx,WM_THEMECHANGED                          ;31Ah - highest handled message
        JA      DefWindowProc

;------------------------------------------------------------------------------

;WM_HSCROLL/WM_VSCROLL

        push    ebp
        cmp     cx,WM_HSCROLL                                ;114h
        mov     ebp,esp
        jz      Scrol0

        cmp     cx,WM_VSCROLL                                ;115h
        jnz     Wheel0

;----------------------

Scrol0: push    ebx
        shl     ecx,6                                        ;cg.v-cg.h = HvOfs = 64 = 2^6
        push    esi
        lea     ebx,cg[ecx-HvOfs*WM_HSCROLL]                 ;EBX points to either cg.h or cg.v structure
        push    edi
        movzx   ecx,word ptr [ebp+16]                        ;ECX = wParam low word = SB_request
        mov     eax,[ebx].CoordInfo.s.nPos
        cmp     ecx,SB_THUMBTRACK                            ;SB_THUMBTRACK = 5
        mov     edx,[ebx].CoordInfo.CellSize
        jz      Scrol4

        xor     esi,esi
        cmp     ecx,SB_LEFT                                  ;SB_LEFT or SB_TOP = 6
        jz      Scrol5

        or      ecx,ecx                                      ;SB_LINELEFT or SB_LINEUP = 0
        mov     esi,eax
        jz      Scrol3

        mov     edi,[ebx].CoordInfo.s.nMax
        sub     edi,[ebx].CoordInfo.s.nPage
        inc     edi
        cmp     ecx,SB_LINERIGHT                             ;SB_LINERIGHT or SB_LINEDOWN = 1
        jz      Scrol1

        cmp     ecx,SB_RIGHT                                 ;SB_RIGHT or SB_BOTTOM = 7
        jz      Scrol2

        mov     edx,[ebx].CoordInfo.s.nPage
        cmp     ecx,SB_PAGELEFT                              ;SB_PAGELEFT or SB_PAGEUP = 2
        jz      Scrol3

        cmp     ecx,SB_PAGERIGHT                             ;SB_PAGERIGHT or SB_PAGEDOWN = 3
        jnz     Scrol6

Scrol1: add     esi,edx
        jc      Scrol2

        cmp     esi,edi
        jbe     Scrol5

Scrol2: mov     esi,edi
        jmp short Scrol5

Scrol3: sub     esi,edx
        jnc     Scrol5

        xor     esi,esi
        jmp short Scrol5

Scrol4: movzx   esi,word ptr [ebp+18]                        ;ESI = wParam high word = position

Scrol5: cmp     eax,esi
        jz      Scrol6

        mov     [ebx].CoordInfo.s.nPos,esi
        INVOKE  SetScrollInfo,[ebp+20],SB_CTL,ebx,TRUE       ;[EBP+20] = lParam = control handle
        mov     eax,[ebx].CoordInfo.Mult
        mov     ecx,[ebx].CoordInfo.Shft
        mul     esi
        shr     edx,cl
        cmp     edx,[ebx].CoordInfo.CurPos
        jz      Scrol6

        mov     [ebx].CoordInfo.NewPos,edx
        INVOKE  InvalidateRgn,chs.hTxt,NULL,TRUE

Scrol6: pop     edi

Scrol7: pop     esi
        pop     ebx

Scrol8: pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

;WM_MOUSEWHEEL/WM_MOUSEHWHEEL

Wheel0: xor     eax,eax
        cmp     cx,WM_MOUSEWHEEL                             ;20Ah
        mov     edx,CID_VSCROLLBAR and STATE_MASK            ;4
        jz      Wheel1

        cmp     cx,WM_MOUSEHWHEEL                            ;20Eh
        jnz     WndPr0

        mov     al,WKEY_SHIFT or WKEY_CONTROL                ;0Ch
        shr     edx,1                                        ;EDX = CID_HSCROLLBAR and STATE_MASK = 2

;----------------------

Wheel1: movzx   ecx,byte ptr rvs.WheelKeys
        cmp     cl,WKEY_SHIFT or WKEY_CONTROL
        jae     Scrol8

        test    cl,WKEY_CONTROL
        jnz     Wheel2

        test    edx,pvs.WinStates
        jz      Scrol8

Wheel2: add     eax,ecx                                      ;normal vert has no disable
        jz      Wheel3

        cmp     al,10h
        ja      Scrol8

        mov     edx,WheelPtrs[eax-4]                         ;normal vert has no disable
        cmp     ah,[edx]                                     ;CH = MF_UNCHECKED = 0
        jz      Scrol8

Wheel3: push    ebx
        push    esi
        push    eax
        sub     esp,sizeof RECT
        INVOKE  GetClientRect,[ebp+8],esp
        pop     edx
        pop     eax
        pop     esi                                          ;ESI = cr.right
        movzx   edx,word ptr [ebp+22]                        ;EDX = lParam high word = y screen coordinate
        pop     ebx                                          ;EBX = cr.bottom
        movzx   eax,word ptr [ebp+20]                        ;EAX = lParam low word = x screen coordinate
        push    edx
        push    eax
        INVOKE  ScreenToClient,[ebp+8],esp
        pop     eax
        pop     edx
        or      eax,eax
        pop     ecx
        js      Scrol7

        or      edx,edx
        js      Scrol7

        cmp     eax,esi
        jae     Scrol7

        test byte ptr pvs.WinStates,CID_STATUSBAR and STATE_MASK ;1
        jz      Wheel4

        sub     ebx,StbHeight

Wheel4: cmp     ebx,edx
        jbe     Scrol7

        push    WHEEL_DELTA                                  ;120
        movsx   edx,word ptr [ebp+18]                        ;EDX = wParam high word = distance
        pop     eax                                          ;EAX = WHEEL_DELTA
        mov     ebx,WM_VSCROLL                               ;115h
        push    edi
        jmp dword ptr WheelVect[ecx]

WhShf:: push    SB_PAGERIGHT                                 ;3, also SB_PAGEDOWN
        jmp short Wheel5

WhNrm:: push    SB_LINERIGHT                                 ;1, also SB_LINEDOWN
        mov     eax,cg.h.WheelDiv

Wheel5: mov     edi,chs.hHScroll
        dec     ebx                                          ;WM_HSCROLL = 114h
        mov     ecx,offset cg.h.WheelCnt
        jmp short Wheel7

WvShf:: push    SB_PAGEUP                                    ;2, also SB_PAGELEFT
        jmp short Wheel6

WvNrm:: push    SB_LINEUP                                    ;0, also SB_LINELEFT
        mov     eax,cg.v.WheelDiv

Wheel6: mov     edi,chs.hVScroll
        mov     ecx,offset cg.v.WheelCnt

Wheel7: pop     esi
        add     edx,[ecx]
        push    ecx
        push    edx
        jns     Wheel9

        xor     esi,SB_LINEUP xor SB_LINEDOWN                ;1
        neg     edx
        jmp short Wheel9

Wheel8: push    edx
        push    eax
        INVOKE  PostMessage,[ebp+8],ebx,esi,edi
        pop     eax
        pop     edx

Wheel9: sub     edx,eax
        jnc     Wheel8

        pop     ebx
        add     eax,edx
        or      ebx,ebx
        pop     ecx
        jns     WheelA

        neg     eax

WheelA: mov     [ecx],eax

WheelB: pop     edi
        pop     esi
        pop     ebx
        pop     ebp
        xor     eax,eax
        ret     16

WvCtl:: push    2
        or      edx,edx
        pop     ecx
        jns     WheelC

        neg     edx
        neg     ecx

WheelC: cmp     eax,edx
        ja      WheelB

        mov     cg.v.WheelCnt,esi
        pop     edi
        pop     esi
        mov     eax,pvs.SizeID
        pop     ebx
        add     eax,ecx
        jmp     CmmndA

;------------------------------------------------------------------------------

WndPr0: cmp     ecx,WM_SIZE                                  ;5
        mov     edx,[ebp+8]                                  ;hWnd
        jz      wSize0

        cmp     ecx,WM_GETMINMAXINFO                         ;24h
        jz      MinMx0

;------------------------------------------------------------------------------

;WM_MOVE

        cmp     ecx,WM_MOVE                                  ;3
        jnz     Keys00

;----------------------

        call    IsNotNormal
        jnz     wMove0

        call dword ptr wrUpdate

wMove0: pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

;WM_SIZE

;wParam:
;
;SIZE_RESTORED  EQU 0
;The window has been resized, but neither the SIZE_MINIMIZED nor SIZE_MAXIMIZED value applies
;
;SIZE_MINIMIZED EQU 1
;The window has been minimized
;
;SIZE_MAXIMIZED EQU 2
;The window has been maximized
;
;SIZE_MAXSHOW   EQU 3
;Message is sent to all pop-up windows when some other window has been restored to its former size
;
;SIZE_MAXHIDE   EQU 4
;Message is sent to all pop-up windows when some other window is maximized

wSize0: shr     ecx,1                                        ;ECX = 2
        sub     ecx,[ebp+16]                                 ;wParam
        jz      wSize3                                       ;SIZE_MAXIMIZED

        jc      wSize4                                       ;SIZE_MAXSHOW or SIZE_MAXHIDE

        sub     cl,2
        jz      wSize1                                       ;SIZE_RESTORED

        inc     ecx
        mov     pvs.MaxFlag,edx                              ;SIZE_MINIMIZED
        mov     rvs.MinFlag,ecx
        jmp short wSize4

wSize1: cmp     cl,rvs.WrFlag
        jz      wSize2

        call    WrAdj

wSize2: push    edx
        call dword ptr wrUpdate
        pop     ecx

wSize3: mov     pvs.MaxFlag,ecx
        movzx   ecx,word ptr [ebp+20]                        ;lParam low word = client width
        movzx   eax,word ptr [ebp+22]                        ;lParam high word = client height
        mov     rvs.MinFlag,ecx
        call    wmSize

;----------------------

wSize4: pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

;WM_GETMINMAXINFO

MinMx0: mov     edx,[ebp+20]                                 ;lParam
        mov     [edx].MINMAXINFO.ptMinTrackSize.x,208

MinMx1: pop     ebp
        xor     eax,eax
        ret     16

;------------------------------------------------------------------------------

Keys00: cmp     cx,WM_KEYUP                                  ;101h
        mov     eax,[ebp+16]                                 ;wParam
        jz      Keys06

        cmp     cx,WM_KEYDOWN                                ;100h
        jnz     Keys07

;----------------------

;WM_KEYDOWN

        test byte ptr [ebp+23],(KF_REPEAT/100h) ;lParam high byte, 40h
        jnz     Keys05

        cmp     eax,VK_SHIFT                                 ;10h
        mov     edx,WKEY_SHIFT                               ;4
        jz      Keys01

        shl     edx,1                                        ;EDX = WKEY_CONTROL = 8
        cmp     eax,VK_CONTROL                               ;11h
        jnz     Keys05

;----------------------

Keys01: test    dl,rvs.WheelKeys
        jz      Keys03

        jmp short Keys05

Keys02: test    dl,rvs.WheelKeys
        jz      Keys05

Keys03: xor     rvs.WheelKeys,dl

Keys04: xor     eax,eax
        mov     cg.h.WheelCnt,eax
        mov     cg.v.WheelCnt,eax

Keys05: pop     ebp
        JMP     DefWindowProc

;----------------------

;WM_KEYUP

Keys06: cmp     eax,VK_SHIFT                                 ;10h
        mov     edx,WKEY_SHIFT                               ;4
        jz      Keys02

        shl     edx,1                                        ;EDX = WKEY_CONTROL = 8
        cmp     eax,VK_CONTROL                               ;11h
        jz      Keys02

        jmp     Keys05

;----------------------

Keys07: cmp     cx,WM_SYSKEYDOWN                             ;104h
        jz      Keys09

        cmp     cx,WM_SYSKEYUP                               ;105h
        jz      Keys0A

        cmp     ecx,WM_SETFOCUS                              ;7
        jz      Keys0B

        cmp     cx,WM_EXITMENULOOP                           ;212h
        jz      Keys08

        cmp     cx,WM_COPYDATA                               ;4Ah
        jz      CData0

        cmp     cx,WM_ENTERMENULOOP                          ;211h
        jnz     Cmmnd0

;----------------------

;WM_ENTERMENULOOP

        mov     edx,WKEY_MLOOP                               ;20h
        jmp     Keys01

;----------------------

;WM_EXITMENULOOP

;we may or may not see the first ALT key down message
;we will see the ALT key up message, however

Keys08: mov     edx,WKEY_MLOOP                               ;20h
        jmp     Keys02

;----------------------

;WM_SYSKEYDOWN (must exit via DefWindowProc)

;because we may or may not see the first ALT key down message,
;we can't ignore repeats like WM_KEYDOWN

Keys09: cmp     eax,VK_MENU                                  ;12h
        mov     edx,WKEY_ALT                                 ;10h
        jz      Keys01

        jmp     Keys05

;----------------------

;WM_SYSKEYUP (must exit via DefWindowProc)

Keys0A: cmp     eax,VK_MENU                                  ;12h
        mov     edx,WKEY_ALT                                 ;10h
        jz      Keys02

        jmp     Keys05

;----------------------

;WM_SETFOCUS

Keys0B: push    ebx
        INVOKE  GetKeyState,VK_SHIFT                         ;10h
        shr     eax,13
        and     eax,WKEY_SHIFT                               ;4
        xchg    eax,ebx
        INVOKE  GetKeyState,VK_CONTROL                       ;11h
        shr     eax,12
        and     eax,WKEY_CONTROL                             ;8
        or      ebx,eax
        INVOKE  GetKeyState,VK_MENU                          ;12h
        shr     eax,7
        and     eax,WKEY_ALT                                 ;10h
        or      eax,ebx
        pop     ebx
        mov     rvs.WheelKeys,al
        jmp     Keys04

;------------------------------------------------------------------------------

;WM_COPYDATA

;CopyDataStruct STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

;CopyDataHdr STRUCT
; hXmtr     dd ?
; hRcvr     dd ?
; nSequence dd ?
; dwCommand dd ?

CData0: mov     eax,[ebp+16]                                 ;wParam
        mov     ecx,ams.hRcvr
        push    ebx
        mov     edx,[ebp+20]                                 ;lParam
        cmp     eax,ecx
        mov     ebx,hWin
        jz      CData1

        or      ecx,ecx
        jnz     CData4

CData1: cmp     ebx,[edx].COPYDATASTRUCT.dwData
        mov     ecx,[edx].COPYDATASTRUCT.cbData
        jnz     CData4

        sub     ecx,sizeof CopyDataHdr
        mov     edx,[edx].COPYDATASTRUCT.lpData
        jc      CData4

        cmp     eax,[edx].CopyDataHdr.hXmtr
        jnz     CData4

        cmp     ebx,[edx].CopyDataHdr.hRcvr
        mov     eax,[edx].CopyDataHdr.dwCommand
        jnz     CData4

        xor     ebx,ebx
        cmp     eax,ams.nBaseCmd                             ;alias for dCm_ACKNOWLEDGE
        ja      CData2

        jb      CData4

        cmp     ebx,ams.hRcvr
        jnz     CData3

        mov     eax,[edx].CopyDataHdr.hXmtr
        mov     ams.hRcvr,eax
        INVOKE  SndAck,ebx
        inc     ebx
        mov     rvs.SequenceX,ebx
        jmp short CDat1

CData2: cmp     ebx,ams.hRcvr
        jz      CData4

CData3: cmp     eax,ams.nMaxCmd
        mov     ebx,[edx].CopyDataHdr.nSequence
        ja      CData4

        test    al,3
        jnz     CData4

        sub     eax,ams.nBaseCmd
        add     eax,ams.lpCmdVect
        jmp dword ptr [eax]

;ams AppModeStruct
; hRcvr         dd ?
; nBaseCmd      dd ?  ;dCU_Base or dCP_Base (equates)
; nMaxCmd       dd ?  ;dCU_MaxCmd or dCP_MaxCmd (equates)
; lpCmdVect     dd ?  ;command dispatch vector table
; AppNamePtr    dd ?

;EAX = CopyDataHdr.dwCommand
;EBX = CopyDataHdr.nSequence
;ECX = COPYDATASTRUCT.cbData - sizeof CopyDataHdr (size of COPYDATA data)
;EDX = COPYDATASTRUCT.lpData (address of CopyDataHdr structure)

CData4: pop     ebx
        pop     ebp
        JMP     DefWindowProc

CDat0:: INVOKE  SndAck,ebx

CDat1:: pop     ebx
        jmp     wSize4

;------------------------------------------------------------------------------

;WM_COMMAND

Cmmnd0: and     eax,0FFFFh
        cmp     cx,WM_COMMAND                                ;111h
        jnz     WndPr1

;----------------------

        cmp     eax,IDM_VIEW_RESETBACK                       ;40
        jz      Cmmnd1

        cmp     eax,IDM_VIEW_RESETFORE                       ;41
        jz      Cmmnd1

        cmp     eax,IDM_FILE_SAVEAS                          ;32
        jz      Cmmnd2

        cmp     eax,IDM_FORE_COLOR                           ;37
        jz      Cmmnd3

        cmp     eax,IDM_BACK_COLOR                           ;38
        jz      Cmmnd3

        cmp     eax,IDM_HELP_HELP                            ;34
        jz      Cmmnd4

        cmp     eax,IDM_HELP_ABOUT                           ;35
        jz      Cmmnd5

;------------------------------------------------------------------------------

;IDM_VIEW_STATUSBAR

        cmp     eax,IDM_VIEW_STATUSBAR                       ;39
        jnz     Cmmnd7

;----------------------

        push    ebx
        push    esi
        call    StbToggle
        jmp     Scrol7

;------------------------------------------------------------------------------

;IDM_VIEW_RESETBACKFORE/IDM_VIEW_RESETFORE

Cmmnd1: shl     eax,6
        push    edi
        add     eax,offset cc-BfOfs*IDM_VIEW_RESETBACK
        push    esi
        xchg    eax,edi
        call    CcRst
        pop     esi
        pop     edi
        jmp     wSize4

;------------------------------------------------------------------------------

;IDM_FILE_SAVEAS

Cmmnd2: mov     edx,offset rvs.FSSemaphore
        mov     ecx,offset FSaveAs
        jmp short Cmmnd6

;----------------------

;IDM_FORE_COLOR/IDM_BACK_COLOR

Cmmnd3: mov     edx,offset rvs.CCSemaphore
        mov     ecx,offset CColor
        jmp short Cmmnd6

;----------------------

;IDM_HELP_HELP

Cmmnd4: mov     edx,offset rvs.HHSemaphore
        mov     ecx,offset HHelp
        jmp short Cmmnd6

;----------------------

;IDM_HELP_ABOUT

Cmmnd5: mov     edx,offset rvs.HASemaphore
        mov     ecx,offset HAbout

Cmmnd6: INVOKE  DlgThread,ecx,edx,eax
        jmp     wSize4

;------------------------------------------------------------------------------

;IDM_VIEW_MWSHFTVRT/IDM_VIEW_MWCTRLVRT
;IDM_VIEW_MWHRZ/IDM_VIEW_MWSHFTHRZ

Cmmnd7: cmp     eax,IDM_VIEW_MWSHFTVRT                       ;42
        jb      Cmmnd9

        cmp     eax,IDM_VIEW_MWSHFTHRZ                       ;45
        ja      Cmmnd9

;----------------------

        mov     edx,eax
        shl     edx,2
        add     edx,offset WheelPtrs-4*IDM_VIEW_MWSHFTVRT
        mov     edx,[edx]
        mov     ecx,[edx]
        xor     ecx,MF_CHECKED
        mov     [edx],ecx
        INVOKE  CheckMenuItem,hMenu,eax,ecx
        jmp     wSize4

;------------------------------------------------------------------------------

Cmmnd8: pop     ebp
        JMP     DefWindowProc

Cmmnd9: cmp     eax,IDM_FILE_EXIT                            ;33
        jz      CmmndC

;------------------------------------------------------------------------------

;IDM_TEXT_SIZE

CmmndA: cmp     eax,IDM_TEXT_SIZE                            ;65
        jb      TxPop

        cmp     eax,FeCount
        jae     Cmmnd8

        test    eax,1
        jz      Cmmnd8

        mov     edx,pvs.SizeID
        cmp     eax,edx
        jz      wSize4

;----------------------

        push    eax
        INVOKE  CheckMenuItem,hMenu,edx,MF_BYCOMMAND or MF_UNCHECKED
        INVOKE  DeleteObject,hFont
        pop     edx
        call    SelectSize
        call    MakeFont
        call    TextCalc
        call    sUpdate
        jmp     wSize4

;------------------------------------------------------------------------------

;IDM_EDIT_COPYALL/IDM_EDIT_COPYFORUM

TxPop:: cmp     eax,IDM_EDIT_COPYALL                         ;36
        jz      CmmndB

        cmp     eax,IDM_EDIT_COPYFORUM                       ;47 (IDM_EDIT_COPYALL+11)
        jnz     WndPr2

;----------------------

CmmndB: sub     eax,IDM_EDIT_COPYALL-COPY_MODE
        INVOKE  CbCopy,eax
        jmp     wSize4

;------------------------------------------------------------------------------

;IDM_FILE_EXIT

CmmndC: INVOKE  PostMessage,edx,WM_SYSCOMMAND,SC_CLOSE,NULL

CmmndD: mov     eax,wrDis
        xchg    eax,wrUpdate
        jmp     wSize4

;------------------------------------------------------------------------------

WndPr1: cmp     ecx,WM_CREATE                                ;1
        jz      WndPr3

        cmp     ecx,WM_CLOSE                                 ;10h
        jz      WndPr4

        cmp     ecx,WM_DESTROY                               ;2
        jz      WndPr6

        cmp     cx,WM_NCDESTROY                              ;82h
        jz      WndPr7

        cmp     ecx,WM_SETTINGCHANGE                         ;1Ah
        jz      WndPr8

        cmp     ecx,WM_THEMECHANGED                          ;31Ah
        jz      WndPr9

        cmp     ecx,WM_DISPLAYCHANGE                         ;7Eh
        jz      WndPrA

;----------------------

WndPr2: pop     ebp
        JMP     DefWindowProc

;------------------------------------------------------------------------------

;WM_CREATE

WndPr3: push    ebx
        push    esi
        push    edi
        call    wmCreate
        jmp     Scrol6

;------------------------------------------------------------------------------

;WM_CLOSE

WndPr4: mov     eax,ams.hRcvr
        or      eax,eax
        jz      WndPr5

        cmp     eax,[ebp+16]
        jz      WndPr5

        push    edx
        INVOKE  SendMessage,eax,WM_CLOSE,edx,edx
        pop     edx

WndPr5: INVOKE  DestroyWindow,edx
        jmp     CmmndD

;------------------------------------------------------------------------------

;WM_DESTROY

WndPr6: mov     rvs.BufDisable,cl
        INVOKE  PostQuitMessage,NULL
        jmp     CmmndD

;------------------------------------------------------------------------------

;WM_NCDESTROY

WndPr7: push    ebx
        push    esi
        push    edi
        call    dWinExit
        jmp     Scrol6

;------------------------------------------------------------------------------

;WM_SETTINGCHANGE

WndPr8: cmp dword ptr [ebp+16],SPI_SETNONCLIENTMETRICS       ;wParam = 2Ah
        jnz     wSize4

;----------------------

;WM_THEMECHANGED

WndPr9: push    ebx
        push    esi
        push    edi
        call    StMet                                        ;status bar metrics
        call    ScMet                                        ;scroll bar/wheel metrics
        jmp     Scrol6

;------------------------------------------------------------------------------

;WM_DISPLAYCHANGE

WndPrA: push    edx
        call    WkMet                                        ;screen width/height
        pop     edx
        call    IsNotNormal
        jnz     WndPrB

        call    WrAdj                                        ;window size/position
        jmp     wSize4

WndPrB: mov     rvs.WrFlag,al
        jmp     wSize4

;------------------------------------------------------------------------------

WndProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

PutcBuff PROC

;Call With: ESI = offset of WndProc hWnd parameter on the stack
;
;the routine returns nothing
;the message is stored and the pointers are updated
;if the buffer overflows, the new message is not stored
;access to the buffer during write is blocked by setting cBuffTail to 0
;
;except for ESI, all registers must be preserved

;cBuffQty        equ 256
;cBuffEnable     dd 0
;cBuffHead       dd cBuff
;cBuffTail       dd cBuff
;cBuff           dd 4*cBuffQty dup(?)   ;in uninitialized data section
;cBuffEnd        equ $

        push    edi
        push    ebx
        xor     edi,edi
        mov     ebx,1
        jmp short PcBuf1

PcBuf0: INVOKE  Sleep,ebx

PcBuf1: xchg    edi,cBuffTail
        or      edi,edi
        jz      PcBuf0

        lea     ebx,[edi+16]
        cmp     ebx,cBuffEnd
        jb      PcBuf2

        mov     ebx,offset cBuff

PcBuf2: cmp     ebx,cBuffHead
        jnz     PcBuf3

        xchg    edi,cBuffTail
        jmp short PcBuf4

PcBuf3: movsd
        movsd
        movsd
        movsd
        xchg    ebx,cBuffTail

PcBuf4: pop     ebx
        pop     edi
        ret

PutcBuff ENDP

;*************************************************************************************************************

StbToggle PROC

        mov     eax,StbState
        xor     al,MF_CHECKED
        mov     ebx,pvs.MaxFlag
        push    eax
        mov     StbState,eax
        INVOKE  CheckMenuItem,hMenu,IDM_VIEW_STATUSBAR,eax
        or      ebx,ebx
        pop     ecx
        jz      CtlUpdate                         ;EBX = hWin if not maximized

        mov     edx,StbHeight
        jecxz   Toggl0                            ;turning it off

        neg     edx                               ;turning it on

Toggl0: mov     eax,wr.bottom
        mov     esi,wr.top
        sub     eax,esi
        sub     eax,edx
        jecxz   Toggl1                            ;turning it off

        cmp     eax,WrkHeight
        ja      CtlUpdate

Toggl1: mov     edx,wr.left
        mov     ecx,wr.right
        sub     ecx,edx
        INVOKE  MoveWindow,ebx,edx,esi,ecx,eax,TRUE
        ret

StbToggle ENDP

;*************************************************************************************************************

CtlUpdate PROC

        sub     esp,sizeof RECT
        INVOKE  GetClientRect,hWin,esp
        pop     eax
        pop     edx
        pop     ecx
        pop     eax

;*******************************************************

;wmSize

;Call With: EAX = client height
;           ECX = client width
;
;  Returns: EAX = nonzero if InvalidateRgn was called to update text window
;
;Each control window has a bit in WinStates that indicates the current show/hide state for that window.
;The "old" WinStates flags reside in the pvs.WinStates dword.
;The "new" WinStates flags reside at [EBP-12], and replaces the "old" WinStates flags when done.
;
;For each control window, the new state/position is calculated.
;If a control window needs to be repositioned, ESI is incremented and 7 parameters are pushed onto the stack.
;These represent the last 7 of the 8 parameters for DeferWindowPos, or the 7 parameters for SetWindowPos.
;For DeferWindowPos, the remaining parameter is pushed inside the defer loop.
;Also, the new position and size values for the control window are updated for later comparison.
;
;Once the stack is set up and the newWinStates dword is created:
; 1) defer window positions as required (ESI indicates count) or set window position for a single window
; 2) hide any control windows that are showing and need to be hidden
;    show any control windows that are hidden and need to be showing
; 3) update WinStates dword

;----------------------

;stack frame TEXTEQUates

;                     <[EBP+16]> ;RETurn address
;                     <[EBP+12]> ;saved EBX contents
;                     <[EBP+8]>  ;saved ESI contents
;                     <[EBP+4]>  ;saved EDI contents
;                     <[EBP]>    ;saved EBP contents
hUpdate       TEXTEQU <[EBP-4]>  ;horizontal update
vUpdate       TEXTEQU <[EBP-8]>  ;vertical update
newWinStates  TEXTEQU <[EBP-12]> ;new WinStates dword

;----------------------

;SP_FLAGSET            EQU SWP_NOZORDER or SWP_NOACTIVATE or SWP_NOOWNERZORDER
;
;CID_STATUSBAR         EQU 1001h ;4097
;CID_HSCROLLBAR        EQU 1002h ;4098
;CID_VSCROLLBAR        EQU 1004h ;4100
;CID_SIZEBOXN          EQU 1008h ;4104
;CID_SIZEGRIP          EQU 1010h ;4112
;
;chs ControlHandles <>
; hStatus        HWND ? ;ID = 1001h
; hHScroll       HWND ? ;ID = 1002h
; hVScroll       HWND ? ;ID = 1004h
; hSizeBoxNG     HWND ? ;ID = 1008h
; hSizeBoxG      HWND ? ;ID = 1010h
; hTxt           HWND ? ;ID = 1020h

;----------------------

wmSize::
        push    ebx
        push    esi
        push    edi
        push    ebp
        or      ebx,-1
        mov     ebp,esp
        push    ebx
        push    ebx
        xchg    eax,edi                           ;EDI = client height
        inc     ebx                               ;EBX = newWinStates
        mov     eax,cg.v.s.nMax                   ;EAX = cg.v.s.nMax
        mov     edx,ebx                           ;EDX = 0
        mov     esi,ebx                           ;ESI = control update count
        cmp     ebx,StbState
        push    ebx                               ;[EBP-4] = newWinStates

;----------------------

;status bar

        jz      sScrl0

        sub     edi,StbHeight
        inc     ebx                               ;set CID_STATUSBAR bit
        cmp     ecx,StbWidth
        jnz     sStBar

        cmp     edi,StbPosY
        jz      sScrl0

sStBar: push    SP_FLAGSET                        ;uFlags
        inc     esi
        push    StbHeight                         ;cy (height)
        push    ecx                               ;cx (width)
        mov     StbWidth,ecx
        push    edi                               ;y (y pos)
        push    edx                               ;x (x pos)
        mov     StbPosY,edi
        push    edx                               ;hWndInsertAfter
        push    chs.hStatus                       ;hWnd

;----------------------

;scroll bar test-retest

;EAX = cg.v.s.nMax
;EBX = newWinStates
;ECX = client width
;EDX = 0
;ESI = control update count
;EDI = client height (less status bar height)

sScrl0: mov     edx,cg.h.s.nMax
        push    eax
        push    edx
        sub     edx,cg.h.CellSize
        sub     eax,cg.v.CellSize
        cmp     edx,ecx
        jb      sScrl1

        sub     edi,cg.v.BarSize
        or      ebx,CID_HSCROLLBAR and STATE_MASK

sScrl1: cmp     eax,edi
        jb      sSpos0

        sub     ecx,cg.h.BarSize
        test    ebx,CID_HSCROLLBAR and STATE_MASK
        jnz     sScrl2

        cmp     edx,ecx
        jb      sScrl2

        or      ebx,CID_HSCROLLBAR and STATE_MASK
        sub     edi,cg.v.BarSize

sScrl2: or      ebx,CID_VSCROLLBAR and STATE_MASK

;----------------------

;scroll bar page/position

sSpos0: pop     edx
        pop     eax
        sub     edx,ecx
        jnc     sSpos1

        xor     edx,edx

sSpos1: cmp     edx,cg.h.s.nPos
        jae     sSpos2

        mov     hUpdate,edx
        mov     cg.h.s.nPos,edx

sSpos2: sub     eax,edi
        mov     cg.h.s.nPage,ecx
        jnc     sSpos3

        xor     eax,eax

sSpos3: cmp     eax,cg.v.s.nPos
        jae     sVScr0

        mov     vUpdate,eax
        mov     cg.v.s.nPos,eax

;----------------------

;vertical scroll bar

sVScr0: xor     edx,edx
        test    ebx,CID_VSCROLLBAR and STATE_MASK
        mov     cg.v.s.nPage,edi
        mov     eax,SP_FLAGSET
        jz      sHScr0

        push    eax                               ;uFlags
        push    edi                               ;cy (height)
        inc     esi
        push    cg.h.BarSize                      ;cx (width)
        push    edx                               ;y (y pos)
        push    ecx                               ;x (x pos)
        push    edx                               ;hWndInsertAfter
        push    chs.hVScroll                      ;hWnd

;----------------------

;horizontal scroll bar

sHScr0: test    ebx,CID_HSCROLLBAR and STATE_MASK
        jz      sTxtW0

        push    eax                               ;uFlags
        inc     esi
        push    cg.v.BarSize                      ;cy (height)
        push    ecx                               ;cx (width)
        push    edi                               ;y (y pos)
        push    edx                               ;x (x pos)
        push    edx                               ;hWndInsertAfter
        push    chs.hHScroll                      ;hWnd

;----------------------

;text window

sTxtW0: cmp     ecx,pvs.TxtWidth
        jnz     sTxtW1

        cmp     edi,pvs.TxtHeight
        jz      sSzBx0

sTxtW1: push    eax                               ;uFlags
        inc     esi
        mov     pvs.TxtWidth,ecx
        push    edi                               ;cy (height)
        push    ecx                               ;cx (width)
        mov     pvs.TxtHeight,edi
        push    edx                               ;y (y pos)
        push    edx                               ;x (x pos)
        push    edx                               ;hWndInsertAfter
        push    chs.hTxt                          ;hWnd

;----------------------

;size boxes

;EAX = SP_FLAGSET
;EBX = newWinStates
;ECX = text window width
;EDX = 0
;ESI = control update count
;EDI = text window height

sSzBx0: test    ebx,CID_VSCROLLBAR and STATE_MASK
        jz      SetPos

        test    ebx,CID_HSCROLLBAR and STATE_MASK
        jz      SetPos

        test    ebx,CID_STATUSBAR and STATE_MASK
        jz      sSzBx1

        or      ebx,CID_SIZEBOXN and STATE_MASK
        cmp     ecx,pvs.BngPosX
        mov     eax,chs.hSizeBoxNG
        jnz     sSzBx2

        cmp     edi,pvs.BngPosY
        jz      SetPos

        mov     pvs.BngPosX,ecx
        mov     pvs.BngPosY,edi
        jmp short sSzBx2

sSzBx1: or      ebx,CID_SIZEGRIP and STATE_MASK
        cmp     ecx,pvs.BsgPosX
        mov     eax,chs.hSizeBoxG
        jnz     sSzBx2

        cmp     edi,pvs.BsgPosY
        jz      SetPos

        mov     pvs.BsgPosX,ecx
        mov     pvs.BsgPosY,edi

sSzBx2: push    SP_FLAGSET                        ;uFlags
        push    cg.v.BarSize                      ;cy (height)
        inc     esi
        push    cg.h.BarSize                      ;cx (width)
        push    edi                               ;y (y pos)
        push    ecx                               ;x (x pos)
        push    edx                               ;hWndInsertAfter
        push    eax                               ;hWnd

;----------------------

;set window position(s)

;ESI = window update count
;stack: 7 parms per ESI count

SetPos: dec     esi
        mov     newWinStates,ebx
        jz      sSetWP

        inc     esi
        jz      State0

        INVOKE  BeginDeferWindowPos,esi

sDefer: push    eax
        CALL    DeferWindowPos
        dec     esi
        jnz     sDefer

        INVOKE  EndDeferWindowPos,eax
        jmp short State0

sSetWP: CALL    SetWindowPos

;----------------------

;    show = newWinStates AND NOT(old_WinStates)
;NOT hide = newWinStates OR NOT(old_WinStates)

;ESI = 0

State0: mov     eax,pvs.WinStates
        mov     edi,offset chs
        mov     ebp,newWinStates
        not     eax
        mov     ebx,ebp
        or      esi,5
        and     ebp,eax              ;EBP = show
        or      ebx,eax              ;EBX = NOT hide
        xor     ecx,ecx
        test    ebp,CID_VSCROLLBAR and STATE_MASK
        jz      State1

        mov     cg.v.WheelCnt,ecx
        
State1: test    ebp,CID_HSCROLLBAR and STATE_MASK
        jz      State2

        mov     cg.h.WheelCnt,ecx

State2: xor     eax,eax
        shr     ebp,1                ;we take 1 bit from EBP and 1 bit from EBX
        rcl     eax,1                ;the result is either 0, 1, or 5
        shl     eax,1                ;a result of 4 won't occur, as it
        shr     ebx,1                ;would indicate both show and hide
        rcl     eax,1
        cmp     al,1                 ;no action required = 1
        jz      State3

        INVOKE  ShowWindow,[edi],eax ;SW_HIDE = 0, SW_SHOW = 5

State3: dec     esi
        lea     edi,[edi+4]          ;next control handle
        jnz     State2

;----------------------

;update scroll bar info and WinStates dword

ScInf0: pop     ebx
        lea     edi,[esi+1]          ;EDI = TRUE
        test    ebx,CID_VSCROLLBAR and STATE_MASK
        mov     pvs.WinStates,ebx
        jz      ScInf1

        INVOKE  SetScrollInfo,chs.hVScroll,SB_CTL,offset cg.v.s,edi

ScInf1: test    ebx,CID_HSCROLLBAR and STATE_MASK
        jz      dsScr0

        INVOKE  SetScrollInfo,chs.hHScroll,SB_CTL,offset cg.h.s,edi

;----------------------

;deadspace scroll update

;ESI = 0
;EDI = 1

dsScr0: inc     edi                  ;EDI = 2 = loop count
        mov     ebx,offset cg.v

dsScr1: pop     eax
        add     eax,1
        jz      dsScr2

        dec     eax
        mov     ecx,[ebx].CoordInfo.Shft
        mul dword ptr [ebx].CoordInfo.Mult
        shr     edx,cl
        mov     [ebx].CoordInfo.NewPos,edx
        cmp     edx,[ebx].CoordInfo.CurPos
        jz      dsScr2

        or      esi,1

dsScr2: sub     ebx,HvOfs            ;64
        sub     edi,1
        jnz     dsScr1

        or      esi,esi
        jz      wSexit

        INVOKE  InvalidateRgn,chs.hTxt,edi,esi

;----------------------

;exit routine

wSexit: pop     ebp
        pop     edi
        pop     esi
        pop     ebx
        ret

CtlUpdate ENDP

;*************************************************************************************************************

dCC_Acknowledge PROC

;EBX = CopyDataHdr.nSequence
;ECX = COPYDATASTRUCT.cbData - sizeof CopyDataHdr (size of COPYDATA data)
;EDX = COPYDATASTRUCT.lpData (address of CopyDataHdr structure)

P_Ack0: mov     eax,pvs.SeqFlush
        or      eax,eax
        jz      P_Ack0

        cmp     eax,ebx
        jnz     P_Ack1

        xchg    eax,rvs.SequenceR

P_Ack1: jmp     CDat1        ;no ack return

dCC_Acknowledge ENDP

;*************************************************************************************************************

dCC_Continue PROC

        mov dword ptr cdTimeCnt,cdTIMEOUT
        jmp     CDat1        ;no ack return

dCC_Continue ENDP

;*************************************************************************************************************

dCC_Flush PROC

P_Flsh: mov     eax,pvs.SeqFlush
        or      eax,eax
        jz      P_Flsh

        xchg    eax,rvs.SequenceR
        jmp     CDat1        ;no ack return

dCC_Flush ENDP

;*************************************************************************************************************

dCP_Print PROC

;ECX = COPYDATASTRUCT.cbData - sizeof CopyDataHdr (size of COPYDATA data)
;EDX = COPYDATASTRUCT.lpData (address of CopyDataHdr structure)

        add     edx,sizeof CopyDataHdr
        INVOKE  dTxtOut,edx
        jmp     CDat0        ;send ack return

dCP_Print ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

SndData PROC    dwCmd:UINT,dwLen:UINT,lpDat:LPVOID

;COPYDATASTRUCT STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

;CopyDataHdr STRUCT
; hXmtr     dd ?
; hRcvr     dd ?
; nSequence dd ?
; dwCommand dd ?

        xor     eax,eax
        push    ebx
        xchg    eax,pvs.SeqFlush
        xor     ebx,ebx
        jmp short sData1

sData0: INVOKE  Sleep,ebx

sData1: xchg    ebx,rvs.SequenceX
        or      ebx,ebx
        jz      sData0

        push    esi
        push    edi
        push    ebp
        mov     ebp,esp
        mov     eax,[ebp+24]  ;dwLen
        or      eax,eax
        mov     ecx,eax
        jz      sData4

        add     eax,3
        mov     edi,esp
        and     eax,-4
        mov     esi,-4096
        mov     edx,esp
        sub     edi,eax
        and     edx,esi
        jmp short sData3

sData2: mov     [esp+esi],eax
        add     edx,esi
        add     esp,esi

sData3: cmp     edx,edi
        ja      sData2

        mov     esi,[ebp+28]  ;lpDat
        mov     esp,edi
        mov     eax,ecx
        rep     movsb

sData4: mov     ecx,ams.hRcvr
        push dword ptr [ebp+20]                  ;CopyDataHdr.dwCommand = dwCmd
        mov     edx,hWin
        push    ebx                              ;CopyDataHdr.nSequence
        add     eax,sizeof CopyDataHdr
        push    ecx                              ;CopyDataHdr.hRcvr
        push    edx                              ;CopyDataHdr.hXmtr
        push    esp                              ;COPYDATASTRUCT.lpData
        push    eax                              ;COPYDATASTRUCT.cbData
        push    ecx                              ;COPYDATASTRUCT.dwData
        INVOKE  SendMessage,ecx,WM_COPYDATA,edx,esp
        xor     edi,edi
        mov     esi,ebx
        mov     rvs.SequenceR,edi
        xchg    ebx,pvs.SeqFlush
        mov dword ptr cdTimeCnt,cdTIMEOUT        ;3000 = 15 seconds
        jmp short sData6

sData5: INVOKE  Sleep,5
        dec dword ptr cdTimeCnt
        jz      sData7

sData6: cmp     esi,rvs.SequenceR
        jnz     sData5

        inc     edi

sData7: leave

sData8: inc     esi
        jz      sData8

        xchg    eax,edi                          ;if EAX = 0, timeout occured
        xchg    esi,rvs.SequenceX
        pop     edi
        pop     esi
        pop     ebx
        ret     12

SndData ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

SndCtrl PROC    dwCmd:UINT,nSeq:UINT

;COPYDATASTRUCT STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

;CopyDataHdr STRUCT
; hXmtr     dd ?
; hRcvr     dd ?
; nSequence dd ?
; dwCommand dd ?

        mov     ecx,ams.hRcvr
        push dword ptr [esp+4]                   ;CopyDataHdr.dwCommand = dwCmd
        mov     edx,hWin
        push dword ptr [esp+12]                  ;CopyDataHdr.nSequence
        push    ecx                              ;CopyDataHdr.hRcvr
        push    edx                              ;CopyDataHdr.hXmtr
        push    esp                              ;COPYDATASTRUCT.lpData
        push    sizeof CopyDataHdr               ;COPYDATASTRUCT.cbData
        push    ecx                              ;COPYDATASTRUCT.dwData
        INVOKE  SendMessage,ecx,WM_COPYDATA,edx,esp
        add     esp,sizeof COPYDATASTRUCT+sizeof CopyDataHdr
        ret     8

SndCtrl ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

AckThrd PROC

;COPYDATASTRUCT STRUCT
; dwData    dd ?
; cbData    dd ?
; lpData    dd ?

;CopyDataHdr STRUCT
; hXmtr     dd ?
; hRcvr     dd ?
; nSequence dd ?
; dwCommand dd ?

        mov     ecx,ams.hRcvr
        push    dCU_ACKNOWLEDGE                  ;CopyDataHdr.dwCommand = dwCmd
        mov     edx,hWin
        push dword ptr [esp+8]                   ;CopyDataHdr.nSequence
        push    ecx                              ;CopyDataHdr.hRcvr
        push    edx                              ;CopyDataHdr.hXmtr
        push    esp                              ;COPYDATASTRUCT.lpData
        push    sizeof CopyDataHdr               ;COPYDATASTRUCT.cbData
        push    ecx                              ;COPYDATASTRUCT.dwData
        INVOKE  SendMessage,ecx,WM_COPYDATA,edx,esp
        add     esp,sizeof COPYDATASTRUCT+sizeof CopyDataHdr
        INVOKE  ExitThread,0

AckThrd ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

SndAck  PROC    nSeq:UINT

        pop     edx
        push    AckThrd
        push    4096
        push    edx
        JMP     CreateThrd

SndAck  ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

PrnThrd PROC

        mov     esi,[esp+4]
        INVOKE  SzLen,esi
        inc     eax
        INVOKE  SndData,dCP_PRINT,eax,esi
        mov     al,0
        xchg    al,rvs.rPSemaphore
        INVOKE  ExitThread,0

PrnThrd ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

pTxtOut PROC    lpString:LPSTR

pTxtO0: mov     eax,1
        xchg    al,rvs.rPSemaphore
        or      eax,eax
        jz      pTxtO1

        INVOKE  Sleep,eax
        jmp     pTxtO0

pTxtO1: INVOKE  CreateThrd,eax,PrnThrd,[esp+4]
        ret     4

pTxtOut ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

SzLen   PROC    lpszStr:LPSTR

;SzLen - Get Length of Zero-Terminated String
;DednDave - Dave Sheldon - 8-2010

        mov     edx,[esp+4]
        mov     ecx,7F7F7F7Fh
        test    dl,3
        push    ebx
        jz      SzLen2

        mov     ebx,[edx]
        xor     eax,eax
        or      bl,bl
        jz      SzLen0

        inc     eax
        or      bh,bh
        jz      SzLen0

        test    dl,2
        jnz     SzLen1

        inc     eax
        test    ebx,0FF0000h
        jnz     SzLen1

SzLen0: pop     ebx
        ret     4

SzLen1: or      dl,3
        inc     edx

SzLen2: push    esi
        push    edi
        mov     esi,01010101h
        mov     edi,80808080h

SzLen3: mov     eax,edx
        mov     ebx,[eax]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jnz     SzLen4

        mov     ebx,[eax+4]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jnz     SzLen4

        mov     ebx,[eax+8]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jnz     SzLen4

        mov     ebx,[eax+12]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jnz     SzLen4

        mov     ebx,[eax+16]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jnz     SzLen4

        mov     ebx,[eax+20]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jnz     SzLen4

        mov     ebx,[eax+24]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jnz     SzLen4

        mov     ebx,[eax+28]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jnz     SzLen4

        mov     ebx,[eax+32]
        add     edx,4
        and     ebx,ecx
        sub     ebx,esi
        and     ebx,edi
        jz      SzLen3

SzLen4: mov     ebx,[edx-4]
        lea     eax,[edx-4]
        or      bl,bl
        jz      SzLen5

        inc     eax
        or      bh,bh
        jz      SzLen5

        inc     eax
        test    ebx,0FF0000h
        jz      SzLen5

        inc     eax
        test    ebx,0FF000000h
        jnz     SzLen3

SzLen5: pop     edi
        pop     esi
        sub     eax,[esp+8]
        pop     ebx
        ret     4

SzLen   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

wrUpd   PROC

;This routine keeps the wr RECT structure updated with the most recent normalized window size.
;The height and width are calculated from wr RECT values and saved in the BIN (ini) file at exit.
;This function is disabled at the first sign of exit so that the RECT values are not destroyed.

        INVOKE  GetWindowRect,edx,offset wr

wrDis:: ret

wrUpd   ENDP

;*************************************************************************************************************

FontSize PROC

;Call With: EDX = selected font control ID number

        movzx   eax,word ptr FeList[edx-IDM_TEXT_SIZE]
        mov     pvs.SizeID,edx
        mov byte ptr cg.h.CellSize,ah
        mov byte ptr cg.v.CellSize,al
        ret

FontSize ENDP

;*************************************************************************************************************

SelectSize PROC

;Call With: EDX = selected font control ID number

        call    FontSize
        INVOKE  CheckMenuItem,hMenu,edx,MF_BYCOMMAND or MF_CHECKED
        ret

SelectSize ENDP

;*************************************************************************************************************

MakeFont PROC

;create a handle for the selected text size
;and calculate multiply-to-divide variables

        push    ebx
        call    M2dCalc
        mov     ebx,offset lf
        INVOKE  GetStockObject,OEM_FIXED_FONT
        INVOKE  GetObject,eax,sizeof LOGFONT,ebx
        mov     eax,cg.h.CellSize
        mov     ecx,cg.v.CellSize
        mov     [ebx].LOGFONT.lfWidth,eax
        mov     [ebx].LOGFONT.lfHeight,ecx
        INVOKE  CreateFontIndirect,ebx
        mov     hFont,eax
        pop     ebx
        ret

MakeFont ENDP

;*************************************************************************************************************

M2dCalc PROC

;calculate multiplier and shift values for multiply-to-divide
;input value are not validated
;tested for divisors 4-35 and dividends less than 80000000h

        mov     ebx,offset cg.h.CellSize
        call    MCalc0
        add     ebx,HvOfs

MCalc0: mov     eax,[ebx]
        dec     eax
        bsr     ecx,eax
        push    1
        inc     eax
        pop     edx
        mov     [ebx+8],ecx
        shl     edx,cl
        xchg    eax,ecx
        xor     eax,eax
        div     ecx
        inc     eax
        mov     [ebx+4],eax
        ret

M2dCalc ENDP

;*************************************************************************************************************

IsNotNormal PROC

;returns window state: normal, minimized, maximized
;
;  Returns: EAX = 0 if normal (ZF=1), 1 if minimized (ZF=0), 2 if maximized (ZF=0)
;           all other registers preserved

;            MaxFlag   MinFlag
;Normalized    hWin  client width (could be any value > 1)
;Minimized     hWin       0
;Maximized      0    client width (could be any value > 1)

        xor     eax,eax
        cmp     eax,pvs.MaxFlag
        adc     eax,eax
        cmp     eax,rvs.MinFlag
        rcl     eax,1
        xor     al,3
        ret

IsNotNormal ENDP

;*************************************************************************************************************

StMet   PROC

;get and store status bar height
;
;  Returns: EAX = status bar height
;           ECX = status bar right screen coordinate
;           EDX = status bar top screen coordinate

        sub     esp,sizeof RECT
        INVOKE  GetWindowRect,chs.hStatus,esp
        pop     eax
        pop     edx
        pop     ecx
        pop     eax
        sub     eax,edx
        mov     StbHeight,eax
        ret

StMet   ENDP

;*************************************************************************************************************

ScMet   PROC

;retrieves scroll bar sizes and calculates wheel divider constants
;
;uses EBX, ESI, EDI without preserving them

        push    SPI_GETWHEELSCROLLCHARS
        push    SM_CXVSCROLL
        mov     ebx,offset cg.h.BarSize
        pop     edi                                                 ;SM_CXVSCROLL = 2
        pop     esi                                                 ;SPI_GETWHEELSCROLLCHARS = 108
        call    ScMet0
        add     ebx,HvOfs
        inc     edi                                                 ;SM_CYHSCROLL = 3
        sub     esi,SPI_GETWHEELSCROLLCHARS-SPI_GETWHEELSCROLLLINES ;SPI_GETWHEELSCROLLLINES = 104

ScMet0: INVOKE  GetSystemMetrics,edi
        push    3                                                   ;default wheel step = 3
        mov     [ebx],eax                                           ;cg.h/v.BarSize
        mov     edx,esp
        INVOKE  SystemParametersInfo,esi,NULL,edx,NULL
        pop     ecx
        push    WHEEL_DELTA                                         ;WHEEL_DELTA = 120
        cmp     ecx,1
        pop     eax
        jbe     ScMet1

        xor     edx,edx
        div     ecx
        shl     edx,1
        cmp     edx,ecx
        cmc
        adc     eax,0

ScMet1: mov     [ebx+4],eax                                         ;cg.h/v.WheelDiv
        ret

ScMet   ENDP

;*************************************************************************************************************

WkMet   PROC

;workarea metrics

        sub     esp,sizeof RECT
        mov     eax,esp
        INVOKE  SystemParametersInfo,SPI_GETWORKAREA,NULL,eax,NULL
        pop     eax
        pop     ecx
        pop     edx
        sub     edx,eax
        pop     eax
        sub     eax,ecx
        mov     WrkWidth,edx
        mov     WrkHeight,eax
        ret

WkMet   ENDP

;*************************************************************************************************************

WrAdj   PROC

;Call With: EDX = hWin
;
;  Returns: EDX = hWin

        push    edi
        push    ebx
        push    esi
        push    TRUE                         ;MoveWindow:bRepaint
        sub     esp,sizeof RECT              ;ScnMetric:RECT, MoveWindow:X,Y,nWidth,nHeight
        mov     edi,edx
        INVOKE  GetWindowRect,edx,esp
        push    WrkHeight                    ;ScnMetric:dwScnHeight
        push    WrkWidth                     ;ScnMetric:dwScnWidth
        CALL    ScnMetric                    ;screen metrics
        mov     rvs.WrFlag,ch
        jecxz   WrAdj1

        pop     eax
        pop     edx
        push    edi                          ;MoveWindow:hWnd
        CALL    MoveWindow

WrAdj0: mov     edx,edi
        pop     esi
        pop     ebx
        pop     edi
        ret

WrAdj1: add     esp,28
        jmp     WrAdj0

WrAdj   ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

ScnMetric PROC  dwScnWidth:UINT,dwScnHeight:UINT,dwLeft:LONG,dwTop:LONG,dwRight:LONG,dwBottom:LONG

        xor     ecx,ecx
        lea     ebx,[esp+12]       ;dwLeft
        call    SnMet0
        add     ebx,4              ;dwTop

SnMet0: mov     eax,[ebx+8]        ;EAX = dwRight or dwBottom
        mov     esi,[ebx]          ;ESI = dwLeft or dwTop
        mov     edx,[ebx-8]        ;EDX = dwScnWidth or dwScnHeight
        sub     eax,esi            ;EAX = window width or height
        cmp     eax,edx
        jbe     SnMet1

        inc     ecx
        mov     eax,edx

SnMet1: or      esi,esi
        mov     [ebx+8],eax        ;dwRight or dwBottom now = adjusted window width or height
        jns     SnMet2

        xor     esi,esi
        inc     ecx

SnMet2: add     eax,esi            ;EAX = window right or bottom
        sub     eax,edx
        jbe     SnMet3

        sub     esi,eax
        inc     ecx

SnMet3: mov     [ebx],esi
        ret

ScnMetric ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

CcRst   PROC

;This routine copies the standard custom color set into either background or foreground color sets.
;EDI contains the address of the custom color structure to be updated.
;ESI is not preserved.

        push    16
        mov     esi,offset CustomColors
        pop     ecx
        rep     movsd
        ret

CcRst   ENDP

;*************************************************************************************************************

TestComplete PROC

;displays "Test Complete at hh:mm:ss" message in the status bar
;also, enables File/Save As, and clipboard copy menu items
;these menu items are disabled at program initialization

        pushad
        mov     eax,esp
        INVOKE  GetTimeFormat,LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT or TIME_NOTIMEMARKER,NULL,NULL,eax,32
        push    ' ta '
        push    'etel'
        push    'pmoC'
        push    ' tse'
        push    'T   '
        lea     eax,[esp+2]
        INVOKE  SendMessage,chs.hStatus,SB_SETTEXT,0,eax
        add     esp,52

;*******************************************************

;enables File/Save As, and clipboard copy menu items
;these menu items are disabled at program initialization

TextReady::
        push    IDM_FILE_SAVEAS
        push    IDM_EDIT_COPYFORUM
        push    IDM_EDIT_COPYALL
        push    3
        pop     ecx

Cmplt0: pop     eax
        push    ecx
        INVOKE  EnableMenuItem,hMenu,eax,MF_BYCOMMAND or MF_ENABLED
        pop     ecx
        loop    Cmplt0

        ret

TestComplete ENDP

;*************************************************************************************************************

dNewLine PROC

;dNewLine is equiv to CR/LF
;NextLine is equiv to LF

        mov dword ptr rvs.LocCntX,0

;*******************************************************

NextLine::
        mov     eax,rvs.LocCntY
        mov     edx,dbi.BufCalc2                 ;BufferRows-1
        inc     eax
        cmp     eax,edx
        jbe     NLine1

        push    edi
        mov     ecx,dbi.BufCalc3                 ;RowLength*(BufferRows-1)/4
        push    edx
        mov     edi,dbi.lpDisplayBuf
        push    esi
        movzx   eax,word ptr [edi]
        mov     dl,0Bh
        cmp     eax,cg.h.CellsUsed
        mov     esi,dbi.SecondRowAddr
        jb      NLine0

        or      dl,4

NLine0: rep     movsd
        xor     eax,eax
        mov     ecx,dbi.BufCalc1                 ;RowLength/4
        or      rvs.dUpdateFlags,dl
        rep     stosd
        pop     esi
        pop     eax
        pop     edi

NLine1: mov     rvs.LocCntY,eax
        mov     al,DMODE_NEWLINE

;*******************************************************

mcUpdate::

;Mode Controlled Display Update

;DMODE_NEWLINE      EQU 1                                      ;new line display update mode bit
;DMODE_CLEARLINE    EQU 2                                      ;clear line display update mode bit
;DMODE_TEXTOUT      EQU 4                                      ;text out display update mode bit

        test    al,rvs.dUpdateMode
        jnz     dUpdate

        movzx   eax,byte ptr rvs.sUpdateEnable
        mov     rvs.sUpdateEnable,ah
        push    eax
        call    dUpdate
        pop     eax
        mov     rvs.sUpdateEnable,al
        ret

dNewLine ENDP

;*************************************************************************************************************

ChangeMode PROC

;Change Display Control Mode

;DMODE_MANUAL       EQU 0                                      ;manual display update mode
;DMODE_SEMI_AUTO    EQU DMODE_NEWLINE or DMODE_CLEARLINE       ;semi-auto display update mode
;DMODE_FULL_AUTO    EQU DMODE_SEMI_AUTO or DMODE_TEXTOUT       ;full-auto display update mode
;DMODE_FORCE_UPDATE EQU 100h                                   ;force update on mode change
;
;DMODE_MASK         EQU DMODE_FULL_AUTO or DMODE_FORCE_UPDATE  ;test mask

        movzx   ecx,byte ptr rvs.dUpdateMode
        and     eax,DMODE_MASK
        not     ecx
        mov     rvs.dUpdateMode,al
        test    eax,ecx
        jnz     dUpdate

        ret

ChangeMode ENDP

;*************************************************************************************************************

dUpdate PROC

;dUpdateFlags:
;bit 0 = display update required
;bit 1 = TextCalc required
;bit 2 = cg.h.CellsUsed update required (naturally performs cg.v.CellsUsed update)
;bit 3 = cg.v.CellsUsed update required

;----------------------

;buffer metrics update

        movzx   ecx,byte ptr rvs.dUpdateFlags
        xor     edx,edx
        test    ecx,0Ch
        jz      dUpdt5

        push    esi
        mov     eax,edx
        push    edi
        mov     esi,dbi.LastRowAddr
        push    ebp
        mov     edi,dbi.BufferRows
        push    ebx
        mov     ebp,dbi.RowLength

dUpdt0: or      eax,eax
        movzx   ebx,word ptr [esi]
        jnz     dUpdt1

        or      ebx,ebx
        jz      dUpdt2

        test    ecx,4                  ;cg.h.CellsUsed upd req'd ?
        mov     eax,edi
        jz      dUpdt4                 ;no - exit loop

dUpdt1: cmp     ebx,edx
        jbe     dUpdt2

        mov     edx,ebx

dUpdt2: sub     esi,ebp
        dec     edi
        jnz     dUpdt0

        or      edx,edx
        jnz     dUpdt3

        inc     edx

dUpdt3: or      eax,eax
        mov     cg.h.CellsUsed,edx
        jnz     dUpdt4

        inc     eax

dUpdt4: pop     ebx
        pop     ebp
        mov     cg.v.CellsUsed,eax
        pop     edi
        pop     esi

dUpdt5: cmp     ecx,1
        jz      dUpdt6

        jb      sUpdt2

        push    1
        call    TextCalc
        pop     ecx

dUpdt6: cmp     ch,rvs.sUpdateEnable
        jz      sUpdt1

;*******************************************************

;screen update

sUpdate::
        call    CtlUpdate
        or      eax,eax
        jnz     sUpdt0

        INVOKE  InvalidateRgn,chs.hTxt,eax,TRUE

sUpdt0: xor     ecx,ecx

sUpdt1: mov     rvs.dUpdateFlags,cl

sUpdt2: ret

dUpdate ENDP

;*************************************************************************************************************

TextCalc PROC

;TextCalc must be called whenever the client area data pixel size changes
;this includes changing the client area text data or resizing the font

;Returns: EDX = 0
;         ECX preserved

        push    ebx
        mov     ebx,offset cg
        mov     eax,[ebx].CoordinateGroup.h.CellsUsed
        mov     edx,[ebx].CoordinateGroup.h.CellSize
        inc     eax
        mul     edx
        inc     eax
        mov     [ebx].CoordinateGroup.h.s.nMax,eax
        mov     eax,[ebx].CoordinateGroup.v.CellsUsed
        mov     edx,[ebx].CoordinateGroup.v.CellSize
        inc     eax
        mul     edx
        inc     eax
        mov     [ebx].CoordinateGroup.v.s.nMax,eax
        pop     ebx
        ret

TextCalc ENDP

;*************************************************************************************************************

dClrLine PROC USES EBX nColumn:UINT,nRow:UINT

;clear buffer line from specified position to end of line
;
;1) from nColumn,nRow, clear to end of line
;2) from nColumn-1,nRow, seek backward to find last visible char
;   of course, if nColumn = 0, this is not necessary
;3) adjust row length value to reflect that length
;4) set a flag if it was longer than any current row
;   this flag will be -1 if another row is as long or longer than the previous row length
;   otherwise, it will be the length of the longest row
;
;note: this function does not alter the location counters

        mov     eax,nRow
        mov     ecx,nColumn
        cmp     eax,dbi.BufferRows
        jae     CLine2

        cmp     ecx,dbi.BufferColumns
        jae     CLine2

        mov     ebx,ecx
        mul dword ptr dbi.RowLength
        neg     ecx
        add     eax,dbi.lpDisplayBuf
        movzx   edx,word ptr [eax]
        add     ecx,edx
        jae     CLine2

        mov     [eax],bx
        push    edi
        xchg    eax,edi
        add     edi,ebx
        xor     eax,eax
        add     edi,2
        rep     stosb
        inc     eax                  ;display update required
        cmp     edx,cg.h.CellsUsed
        pop     edi
        jb      CLine0

        mov     al,7
        jmp short CLine1

CLine0: or      ebx,ebx
        mov     ecx,nRow
        jnz     CLine1

        cmp     ecx,cg.v.CellsUsed
        jb      CLine1

        mov     al,0Bh

CLine1: or byte ptr rvs.dUpdateFlags,al
        mov     al,DMODE_CLEARLINE
        call    mcUpdate

CLine2: ret

dClrLine ENDP

;*************************************************************************************************************

StrScan PROC

;scan a text string and return the number of characters preceeding the first "special" character
;special characters include 0,9,10,12,13
;
;Call With: ESI = offset of string
;
;  Returns: EAX = bytes preceeding special char
;           EDX = special char identifier:
;                 0 (12) form feed (used to clear screen)
;                 4 (0) null terminator
;                 5 (9) tab
;                 6 (13) carriage return
;                 7 (10) line feed
;           ZF  = set if EAX = 0, otherwise cleared

        or      ecx,-1
        mov     ebx,7F7F7F7Fh
        push    esi
        mov     edi,9090909h
        xor     ebp,ebp

sScan0: push    edi
        mov     eax,[esi]
        push    ecx
        dec     ebp
        push    5050505h
        mov     ecx,5
        jmp short sScan2

sScan1: pop     edx
        xor     eax,edi
        xor     edi,edx
        ror     ebp,1
        sub     edx,2020202h
        and     edi,7070707h
        push    edx

sScan2: mov     edx,eax
        and     edx,ebx
        add     edx,ebx
        or      edx,eax
        or      edx,ebx
        and     ebp,edx
        dec     ecx
        jnz     sScan1

        pop     edx
        pop     ecx
        add     esi,4
        inc     ecx
        inc     ebp
        pop     edi
        jz      sScan0

        bsf     eax,ebp
        shl     ecx,2
        lea     edx,[eax+1]
        pop     esi
        shr     eax,3
        and     edx,7
        add     eax,ecx
        ret

StrScan ENDP

;*************************************************************************************************************

Justify PROC

;justify the location counter values to insure they are valid

        mov     eax,dbi.BufferColumns
        mov     edx,dbi.BufCalc2            ;BufferRows-1
        cmp     eax,rvs.LocCntX
        jae     Justf0

        mov     rvs.LocCntX,eax

Justf0: cmp     edx,rvs.LocCntY
        jae     Justf1

        mov     rvs.LocCntY,edx

Justf1: ret

Justify ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

dTxtOut PROC    lpTxt:LPSTR

;intended to more-or-less emulate the console StdOut function
;some elements of behaviour mock that of the console - others mock that of a text editor like notepad
;
; 1) The FormFeed character (12) may be used to clear the screen.
; 2) The Bell character (7) is not expanded to a sound; It is a visible character.
; 3) Tabs are expanded to spaces that overwrite existing text, similar to the console.
;    Text editors simply move the cursor or, perhaps, insert spaces.
; 4) Spaces (32) at the end of a line count as visible; Nulls (0) do not.
;    This primarily affects scrollbar behaviour, which is similar to a text editor.
; 5) Because Nulls are used as string terminators, there is no convenient way to clear an area.
;    For this reason, a ClearLine function is provided that will clear to end-of-line from a given position.
;    The ClearLine function does not alter the location counters.
; 6) The dTxtOut function line-wraps and updates location counters, similar to a console.
;    However, I never liked the way the console (or VT-100) handled line-wrap and CR/LF.
;    Therefore, the X location counter has special properties:
;   a) We allow the X location to be equal to the row length (normally, the max is row length - 1).
;      This indicates that the last char on the line has been written, and no more.
;   b) If the current X location is equal to the row length:
;      1) If the buffer location is calculated to stream the next visible char, a NextLine is generated.
;      2) CarriageReturn and LineFeed behave as desired, without inserting extra blank lines.
;      3) A NextLine is generated prior to expanding a Tab.
;   c) Care must be taken if retrieving the current location.
;      The caller must be aware of the maximum valid X position.
; 7) When a line feed is streamed in a console window, the viewable portion is scrolled so
;    that the last line is visible. This behaviour can be irritating if you are trying to view
;    older screen text. In this implementation, a single line is scrolled, instead. This permits
;    the viewing of older text while still letting the viewer know that an update has occured.
; 8) Unlike the console, all text uses the same 2 colours; foreground and background.
;    This version does not implement character attributes.

;----------------------

;prologue

        push    esi
        call    Justify
        push    ebx
        mov     esi,[esp+12]
        push    edi
        dec     esi
        push    ebp

;----------------------

;string scan

dTxtO0: inc     esi
        call    StrScan
        jz      dTxtOC

        or      edx,edx
        jz      dTxtOD

dTxtO1: push    edx

;----------------------

;output to buffer

        mov     ebp,rvs.LocCntX
        mov     ebx,dbi.BufferColumns
        sub     ebx,ebp
        jnz     dTxtO3

        xchg    ebx,ebp

dTxtO2: push    eax
        push    edx
        call    dNewLine
        pop     edx
        pop     eax

dTxtO3: cmp     edx,8
        mov     edi,dbi.RowLength
        mov     ecx,rvs.LocCntY
        jnz     dTxtO5

        cmp     dh,rvs.BufDisable
        jnz     dTxtO4

        mov     eax,ebp
        and     eax,7
        neg     eax
        add     eax,edx
        cmp     eax,ebx
        jbe     dTxtO6

        mov     eax,ebx
        jmp short dTxtO6

dTxtO4: pop     edx
        pop     eax
        pop     eax
        pop     esi
        jmp     dTxtOJ

dTxtO5: cmp     dh,rvs.BufDisable
        jz      dTxtO6

        pop     edx
        jmp     dTxtOJ

dTxtO6: imul    edi,ecx
        mov     dl,dh
        add     edi,dbi.lpDisplayBuf
        cmp     ecx,cg.v.CellsUsed
        jb      dTxtO8

        inc     ecx
        or byte ptr rvs.dUpdateFlags,3
        cmp     dx,[edi]
        mov     cg.v.CellsUsed,ecx
        mov     edx,cg.v.NewPos
        jnz     dTxtO8

        cmp     edx,cg.v.CurPos
        jnz     dTxtO8

        push    ebx
        sub     ecx,edx
        mov     ebx,cg.v.CellSize
        imul    ecx,ebx
        cmp     ecx,pvs.TxtHeight
        jb      dTxtO7

        inc     edx
        mov     cg.v.NewPos,edx
        imul    ebx,edx
        mov     cg.v.s.nPos,ebx

dTxtO7: pop     ebx

dTxtO8: add     edi,2
        mov     ecx,ebx
        push    edi
        add     edi,ebp
        cmp     eax,ebx
        jae     dTxtO9

        mov     ecx,eax
        mov     ebx,eax

dTxtO9: rep     movsb
        add     ebp,ebx
        pop     edi
        mov     rvs.LocCntX,ebp
        mov     edx,edi
        mov     ebp,dbi.BufferColumns
        add     edx,ebp

dTxtOA: dec     edx
        cmp     cl,[edx]
        jz      dTxtOA

        inc     edx
        inc     ecx
        sub     edx,edi
        cmp     edx,cg.h.CellsUsed
        mov     [edi-2],dx
        jbe     dTxtOB

        or      ecx,2
        mov     cg.h.CellsUsed,edx

dTxtOB: or      rvs.dUpdateFlags,cl
        sub     eax,ebx
        push    0
        mov     ebx,ebp
        pop     ebp
        jnz     dTxtO2

;----------------------

;special char dispatch

        pop     edx

dTxtOC: or      edx,edx                  ;form feed
        jz      dTxtOE

        sub     edx,8                    ;tab complete
        jz      dTxtOF

        inc     edx                      ;line feed
        jz      dTxtOG

        inc     edx                      ;carriage return
        jz      dTxtOH

        inc     edx                      ;tab
        jnz     dTxtOI                   ;otherwise, it's the null terminator

;----------------------

;special char = tab

        mov     eax,20202020h
        push    esi
        push    eax
        push    eax
        mov     edx,8                    ;special char indicator = tab complete
        mov     esi,esp
        jmp     dTxtO1

;----------------------

;special char = form feed (clear screen)

dTxtOD: add     esi,eax

dTxtOE: mov     edi,dbi.lpDisplayBuf
        xchg    eax,edx
        mov     ecx,dbi.BufCalc4         ;RowLength*BufferRows/4
        mov     rvs.LocCntX,eax
        rep     stosd
        mov     rvs.LocCntY,eax
        or byte ptr rvs.dUpdateFlags,7
        jmp     dTxtO0

;----------------------

;special char = tab complete

dTxtOF: pop     eax
        pop     edx
        pop     esi
        jmp     dTxtO0

;----------------------

;special char = line feed

dTxtOG: call    NextLine
        jmp     dTxtO0

;----------------------

;special char = carriage return

dTxtOH: mov     rvs.LocCntX,edx
        jmp     dTxtO0

;----------------------

;display update

;EAX = 0

dTxtOI: mov     al,DMODE_TEXTOUT
        call    mcUpdate

;----------------------

;epilogue

dTxtOJ: pop     ebp
        xchg    eax,esi
        pop     edi
        pop     ebx
        sub     eax,[esp+8]
        pop     esi
        ret     4

dTxtOut ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

CbCopy  PROC    USES EBX ESI EDI dwMode:UINT

;copy the conents of the screen buffer to the clipboard
;the optional forum [code] and [/code] tags may be added

        INVOKE  OpenClipboard,hWin
        or      eax,eax
        jz      CCopy4

        xor     esi,esi
        INVOKE  EmptyClipboard
        inc     esi
        or      eax,eax
        jz      CCopy3

        call    ScnLen
        mov     ebx,ecx
        add     eax,dwMode
        mov     edi,edx
        INVOKE  GlobalAlloc,GMEM_MOVEABLE or GMEM_DDESHARE,eax
        or      eax,eax
        jz      CCopy3

        push    eax
        INVOKE  GlobalLock,eax
        mov     ecx,ebx
        mov     edx,edi
        cmp byte ptr dwMode,COPY_MODE
        pop     ebx
        mov     edi,esi
        jz      CCopy0

        mov dword ptr [eax],'doc['
        mov word ptr [eax+4],']e'
        dec     edi
        add     eax,6

CCopy0: call    Scn2File
        xor     edx,edx
        dec     edi
        jz      CCopy1

        mov dword ptr [eax-2],'oc/['
        mov     edx,']ed'
        inc     eax
        inc     eax

CCopy1: mov     [eax],edx
        INVOKE  GlobalUnlock,ebx
        INVOKE  SetClipboardData,CF_OEMTEXT,ebx
        or      eax,eax
        jz      CCopy2

        dec     esi

CCopy2: INVOKE  GlobalFree,ebx

CCopy3: INVOKE  CloseClipboard
        dec     esi
        jnz     CCopy5

CCopy4: INVOKE  MessageBox,hWin,offset CbErrText,offset CbErrTitle,MB_ICONERROR

CCopy5: ret

CbCopy  ENDP

;*************************************************************************************************************

FSaveAs PROC

;File Save As dialog

;OPENFILENAME STRUCT
; lStructSize       dd ?
; hwndOwner         dd ?
; hInstance         dd ?
; lpstrFilter       dd ?
; lpstrCustomFilter dd ?
; nMaxCustFilter    dd ?
; nFilterIndex      dd ?
; lpstrFile         dd ?
; nMaxFile          dd ?
; lpstrFileTitle    dd ?
; nMaxFileTitle     dd ?
; lpstrInitialDir   dd ?
; lpstrTitle        dd ?
; Flags             dd ?
; nFileOffset       dw ?
; nFileExtension    dw ?
; lpstrDefExt       dd ?
; lCustData         dd ?
; lpfnHook          dd ?
; lpTemplateName    dd ?

        push    1
        call    FnAlloc
        pop     ebx                                     ;EBX = 1
        mov dword ptr [eax],'xt.*'
        push    eax                                     ;HFree:hBlock
        mov     SaveAsFlag,ebx
        push    eax
        mov byte ptr [eax+4],'t'
        push    ecx                                     ;lpTemplateName
        push    OFNProc                                 ;lpfnHook
        push    ecx                                     ;lCustData
        push    offset FileTypeStrs+13                  ;lpstrDefExt - 'txt',0
        push    ecx                                     ;nFileOffset/nFileExtension
        push    OFN_LONGNAMES or OFN_HIDEREADONLY or OFN_ENABLEHOOK or OFN_EXPLORER  ;Flags
        push    offset szSaveAs                         ;lpstrTitle
        push    ecx                                     ;lpstrInitialDir
        push    ecx                                     ;nMaxFileTitle
        push    ecx                                     ;lpstrFileTitle
        push    edx                                     ;nMaxFile
        push    eax                                     ;lpstrFile
        push    ebx                                     ;nFilterIndex
        push    ecx                                     ;nMaxCustFilter
        push    ecx                                     ;lpstrCustomFilter
        push    offset FileTypeStrs                     ;lpstrFilter
        push    ecx                                     ;hInstance
        push    ecx                                     ;hwndOwner
        push    76                                      ;lStructSize
        INVOKE  GetSaveFileName,esp
        add     esp,76                                  ;sizeof OPENFILENAME
        cmp     ebx,SaveAsFlag
        pop     esi                                     ;ESI = szFileName pointer
        jz      FSave4

        call    ScnLen
        add     eax,127
        push    ecx
        mov     ebp,edx                                 ;EBP = display buffer base address
        INVOKE  HeapAlloc,dbi.hHeap,NULL,eax
        or      eax,eax
        pop     ecx
        jz      FSave3

        xchg    eax,edi                                 ;EDI = current file buffer pointer
        mov     ebx,0A0D0A0Dh                           ;EBX = cr,lf,cr,lf
        push    edi                                     ;HFree:hBlock
        mov     [edi],ebx
        push    ecx
        inc     edi
        xor     edx,edx
        inc     edi
        INVOKE  GetDateFormat,LOCALE_USER_DEFAULT,edx,edx,offset szDateFormat,edi,127
        push    32
        add     edi,eax
        xor     edx,edx
        pop     eax
        mov     [edi-1],al
        INVOKE  GetTimeFormat,LOCALE_USER_DEFAULT,TIME_FORCE24HOURFORMAT or TIME_NOTIMEMARKER,edx,edx,edi,eax
        add     eax,3
        pop     ecx
        add     eax,edi
        mov     edx,ebp
        mov     [eax-4],ebx
        call    Scn2File
        mov     edx,SaveAsFlag
        xchg    eax,ebp                                 ;EBP = end of buffer
        push    edx
        shr     edx,1                                   ;if we are appending the file,
        add     edx,OPF_FILECREATE                      ;OPF_FILECREATE becomes OPF_FILEWRITE
        INVOKE  OpnFile,esi,edx
        pop     ecx
        xchg    eax,ebx                                 ;EBX = file handle
        push    1
        inc     ebx                                     ;test for INVALID_HANDLE_VALUE
        pop     esi                                     ;ESI = 1 (error flag)
        jz      FSave2

        dec     ebx
        dec     esi                                     ;ESI = 0
        jecxz   FSave0

        INVOKE  SetFilePointer,ebx,esi,esi,ecx

FSave0: pop     edx
        push    edx
        push    esi
        sub     ebp,edx                                 ;EBP = bytes to write
        mov     eax,esp
        INVOKE  WriteFile,ebx,edx,ebp,eax,esi
        pop     esi                                     ;ESI = bytes written
        sub     esi,ebp
        or      eax,eax
        jnz     FSave1

        xchg    eax,esi
        inc     esi                                     ;ESI = 1 (error flag)

FSave1: INVOKE  CloseHandle,ebx

FSave2: CALL    HFree
        or      esi,esi
        jz      FSave4

FSave3: INVOKE  MessageBox,hWin,offset FileErrText,offset FileErrTitle,MB_OK or MB_ICONERROR

FSave4: CALL    HFree
        mov     edx,offset rvs.FSSemaphore
        mov     eax,IDM_FILE_SAVEAS
        jmp     ThreadExit

FSaveAs ENDP

;*************************************************************************************************************

CColor  PROC

;color chooser dialog
;used for both foreground and background

;CHOOSECOLOR STRUCT
; lStructSize      dd ?
; hwndOwner        dd ?
; hInstance        dd ?
; rgbResult        dd ?
; lpCustColors     dd ?
; Flags            dd ?
; lCustData        dd ?
; lpfnHook         dd ?
; lpTemplateName   dd ?

        mov     eax,IDM_BACK_COLOR
        cmp     eax,CCMode
        jnz     CColr0

        mov     eax,IDM_FORE_COLOR

CColr0: push    eax
        INVOKE  EnableMenuItem,hMenu,eax,MF_BYCOMMAND or MF_GRAYED
        pop     eax
        mov     edx,offset vs.BackColor
        cmp     eax,IDM_BACK_COLOR
        mov     ecx,offset cc
        jnz     CColr1

        add     edx,vs.ForeColor-vs.BackColor                ;4
        add     ecx,BfOfs                                    ;64

CColr1: xor     eax,eax
        push    edx                                          ;color pointer
        push    eax                                          ;lpTemplateName
        push    eax                                          ;lpfnHook
        push    eax                                          ;lCustData
        push    CC_ANYCOLOR or CC_FULLOPEN or CC_RGBINIT     ;Flags
        push    ecx                                          ;lpCustColors
        push dword ptr [edx]                                 ;rgbResult
        push    eax                                          ;hInstance
        push    eax                                          ;hwndOwner
        push    sizeof CHOOSECOLOR                           ;lStructSize
        INVOKE  ChooseColor,esp
        mov     ecx,[esp+12]                                 ;rgbResult
        add     esp,sizeof CHOOSECOLOR
        pop     edx                                          ;color pointer
        or      eax,eax
        jz      CColr3

        mov     [edx],ecx
        cmp dword ptr CCMode,IDM_BACK_COLOR
        jnz     CColr2

        INVOKE  CreateSolidBrush,ecx
        INVOKE  SetClassLong,chs.hTxt,GCL_HBRBACKGROUND,eax  ;hBrush
        INVOKE  DeleteObject,eax                             ;delete old brush

CColr2: INVOKE  InvalidateRgn,chs.hTxt,NULL,TRUE

CColr3: INVOKE  EnableMenuItem,hMenu,IDM_FORE_COLOR,MF_BYCOMMAND or MF_ENABLED
        mov     edx,offset rvs.CCSemaphore
        mov     eax,IDM_BACK_COLOR
        jmp short ThreadExit

CColor  ENDP

;*************************************************************************************************************

HHelp   PROC

;help dialog

        INVOKE  MessageBox,NULL,offset HelpText,ams.AppNamePtr,MB_ICONQUESTION
        mov     edx,offset rvs.HHSemaphore
        mov     eax,IDM_HELP_HELP
        jmp short ThreadExit

HHelp   ENDP

;*************************************************************************************************************

HAbout  PROC

;help-about dialog

        INVOKE  ShellAbout,NULL,offset NullStr,offset AboutText,phs.hIcon
        mov     edx,offset rvs.HASemaphore
        mov     eax,IDM_HELP_ABOUT

;*******************************************************

ThreadExit::
        push    edx
        INVOKE  EnableMenuItem,hMenu,eax,MF_BYCOMMAND or MF_ENABLED
        xor     eax,eax
        pop     edx
        xchg    al,[edx]
        dec     eax
        INVOKE  ExitThread,eax

HAbout  ENDP

;*************************************************************************************************************

DlgThread PROC  lpProc:LPVOID,lpSemaphore:LPVOID,dwCtlID:UINT

;creates a thread for file save, color chooser, help, help-about

        push    1
        mov     edx,lpSemaphore
        pop     ecx
        xchg    cl,[edx]
        or      ecx,ecx
        jnz     DlgTh2

        mov     eax,dwCtlID
        cmp     eax,IDM_FORE_COLOR
        jz      DlgTh0

        cmp     eax,IDM_BACK_COLOR
        jnz     DlgTh1

DlgTh0: mov     CCMode,eax

DlgTh1: INVOKE  EnableMenuItem,hMenu,eax,MF_BYCOMMAND or MF_DISABLED
        INVOKE  CreateThrd,4096,lpProc,eax

DlgTh2: ret

DlgThread ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

CreateThrd PROC dwStackSize:DWORD,lpStartAddress:LPVOID,lpParameter:LPVOID

        push    ebp
        xor     eax,eax
        mov     ebp,esp
        push    eax
        INVOKE  CreateThread,eax,[ebp+8],[ebp+12],[ebp+16],eax,esp
        pop     edx
        pop     ebp
        ret     12

CreateThrd ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

OpnFile PROC    lpFileName:LPSTR,dwOpenFlags:DWORD

;file open function

;OPF_FILECREATE EQU GENERIC_WRITE or CREATE_ALWAYS                  (40000002h)
;OPF_FILEWRITE  EQU GENERIC_WRITE or OPEN_EXISTING                  (40000003h)
;OPF_FILEREAD   EQU GENERIC_READ or OPEN_EXISTING                   (80000003h)
;OPF_FILERANDOM EQU GENERIC_READ or GENERIC_WRITE or OPEN_EXISTING  (C0000003h)

        mov     eax,[esp+8]
        xor     ecx,ecx
        movzx   edx,al
        and     eax,0C0000000h
        and     dl,3
        INVOKE  CreateFile,[esp+28],eax,FILE_SHARE_READ,ecx,edx,FILE_ATTRIBUTE_NORMAL,ecx
        ret     8

OpnFile ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

GetExeFile PROC

;Gets the full path and filename of the currently running program.
;The allocated buffer must be freed when done.
;
;  Returns: EAX = address of heap allocated pathname (must be freed)
;           ECX = path/filename string length
;           EDX = heap allocated buffer size

        call    FnAlloc
        push    eax
        push    edx
        INVOKE  GetModuleFileName,ecx,eax,edx
        xchg    eax,ecx
        pop     edx
        pop     eax
        ret

GetExeFile ENDP

;*************************************************************************************************************

GetExePath PROC

;Gets the full path of the currently running program.
;The 'filename.exe' portion of the string is removed, leaving just the path with a trailing "\".
;The allocated buffer must be freed when done.
;
;  Returns: EAX = address of heap allocated pathname (must be freed)
;           ECX = pathname string length
;           EDX = heap allocated buffer size

        call    GetExeFile
        push    eax
        push    edx
        add     eax,ecx
        mov     dx,3A5Ch         ;'\:'
        inc     ecx

EPath0: dec     ecx
        jz      EPath2

        dec     eax
        cmp     dl,[eax]
        jz      EPath1

        cmp     dh,[eax]
        jnz     EPath0

        inc     eax
        inc     ecx
        mov     [eax],dl

EPath1: inc     eax

EPath2: mov byte ptr [eax],0
        pop     edx
        pop     eax
        ret

GetExePath ENDP

;*************************************************************************************************************

MakeIFn PROC

;creates BIN (ini) file name in heap-allocated buffer

;  Returns: EAX = address of heap allocated path/file name (must be freed)
;           ECX = address of 'dTest.bin' string
;           EDX = address of small file buffer (above filename string)

        call    GetExePath
        add     ecx,eax
        mov dword ptr [ecx],'seTd'
        mov     edx,ecx
        mov dword ptr [ecx+4],'ib.t'
        add     edx,13
        mov word ptr [ecx+8],'n'
        and     edx,-4
        ret

MakeIFn ENDP

;*************************************************************************************************************

FnAlloc PROC

;allocate temporary buffer for filenames

;  Returns: EAX = address of allocated block
;           ECX = 0
;           EDX = size of allocated block

        mov     edx,4096
        push    edx
        INVOKE  HeapAlloc,dbi.hHeap,HEAP_ZERO_MEMORY,edx
        xor     ecx,ecx
        pop     edx
        ret

FnAlloc ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

HFree   PROC    hBlock:HANDLE

;frees heap allocation

        pop     edx
        push    NULL
        push    dbi.hHeap
        push    edx
        JMP     HeapFree

HFree   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

ScnLen  PROC

;returns the length of all text in the buffer, adding CR/LF's to the count
;used for file save and copy to clipboard functions

;  Returns: EAX = byte count, including CR/LF's
;           ECX = used row count
;           EDX = dbi.lpDisplayBuf
;
;     Note: If the buffer is empty, EAX will be the count of a CR/LF pair (2).
;           However, ECX will remain 0.
;
;EBX, ESI, EDI, EBP preserved

        push    edi
        mov     eax,cg.v.CellsUsed
        mov     edi,dbi.RowLength
        mov     ecx,eax
        mul     edi
        add     eax,dbi.lpDisplayBuf
        xchg    eax,edx        
        jmp short ScLen1

ScLen0: sub     ecx,1
        jz      ScLen3

ScLen1: sub     edx,edi
        cmp     ax,[edx]
        jz      ScLen0

        push    ebx
        push    ecx

ScLen2: movzx   ebx,word ptr [edx]
        sub     edx,edi
        add     eax,ebx
        sub     ecx,1
        jnz     ScLen2

        pop     ecx
        pop     ebx
        add     eax,ecx
        add     edx,edi
        add     eax,ecx
        pop     edi
        ret

ScLen3: inc     eax
        pop     edi
        inc     eax
        ret

ScnLen  ENDP

;*************************************************************************************************************

Scn2File PROC

;convert the screen buffer to file save format

;Call With: EAX = buffer address
;           ECX = row count
;           EDX = dbi.lpDisplayBuf
;
;  Returns: EAX = address of next byte in buffer
;           ECX = bytes written to buffer
;           EDX = buffer address
;
;     Note: If the function is called with ECX = 0, a CR/LF pair is written to the buffer.

        jecxz   S2Fil3

        push    ebx
        push    eax
        mov     bh,20h

S2Fil0: push    ecx
        push    edx
        movzx   ecx,word ptr [edx]
        inc     edx
        inc     edx

S2Fil1: mov     bl,[edx]
        or      bl,bl
        jnz     S2Fil2

        mov     bl,bh

S2Fil2: mov     [eax],bl
        inc     edx
        inc     eax
        dec     ecx
        jnz     S2Fil1

        mov word ptr [eax],0A0Dh
        pop     edx
        inc     eax
        pop     ecx
        inc     eax
        add     edx,dbi.RowLength
        dec     ecx
        jnz     S2Fil0

        pop     edx
        mov     ecx,eax
        pop     ebx
        sub     ecx,edx
        ret

S2Fil3: mov     edx,eax
        mov     cl,2
        mov word ptr [edx],0A0Dh
        add     eax,ecx
        ret

Scn2File ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

OFNProc PROC    hDlg:HWND,uiMsg:UINT,wParam:WPARAM,lParam:LPARAM

;"Save As" dialog box customization

        cmp dword ptr [esp+8],WM_NOTIFY                          ;uiMsg
        mov     eax,[esp+16]                                     ;lParam
        jnz     OHook0

        cmp dword ptr [eax].OFNOTIFY.hdr.code,CDN_FILEOK
        jz      OHook1

OHook0: xor     eax,eax
        ret     16

OHook1: push    ebx
        mov     edx,[eax].OFNOTIFY.lpOFN
        push    edi
        movzx   ecx,word ptr [edx].OPENFILENAME.nFileExtension
        mov     ebx,[esp+12]                                     ;EBX = hDlg
        mov     edi,[edx].OPENFILENAME.lpstrFile                 ;EDI = offset path/file name
        jecxz   OHook5

        add     ecx,edi
        cmp dword ptr [ecx],'txt'
        jnz     OHook5

        dec     ecx
        mov     edx,ecx
        jmp short OHook3

OHook2: movzx   eax,byte ptr [edx]
        cmp     al,'.'
        jz      OHook4

        cmp     al,'\'
        jz      OHook5

        cmp     al,':'
        jz      OHook5

        cmp     al,'/'
        jz      OHook5

OHook3: dec     edx
        cmp     edx,edi
        ja      OHook2

        jmp short OHook5

OHook4: mov     [ecx],ah

;WIN32_FILE_ATTRIBUTE_DATA STRUCT
; dwFileAttributes dd ?
; ftCreationTime   FILETIME <>
;   dwLowDateTime    dd ?
;   dwHighDateTime   dd ?
; ftLastAccessTime FILETIME <>
;   dwLowDateTime    dd ?
;   dwHighDateTime   dd ?
; ftLastWriteTime  FILETIME <>
;   dwLowDateTime    dd ?
;   dwHighDateTime   dd ?
; nFileSizeHigh    dd ?
; nFileSizeLow     dd ?

OHook5: xor     eax,eax
        push    eax
        push    eax
        sub     esp,sizeof WIN32_FILE_ATTRIBUTE_DATA-8
        INVOKE  GetFileAttributesEx,edi,eax,esp
        add     esp,sizeof WIN32_FILE_ATTRIBUTE_DATA-8
        pop     edx
        pop     eax
        or      eax,edx
        jz      OHook7

        INVOKE  GetCurrentThreadId
        xor     edx,edx
        mov     MbHookFlag,dl
        INVOKE  SetWindowsHookEx,WH_CBT,CBTProc,edx,eax
        mov     hMbHook,eax
        INVOKE  MessageBox,ebx,offset szExists,offset szSaveAs,MB_YESNOCANCEL or MB_ICONEXCLAMATION or MB_DEFBUTTON3
        cmp     eax,IDNO
        jnz     OHook6

        mov     MbHookFlag,al
        INVOKE  MessageBox,ebx,offset szVerify,offset szOverwrite,MB_OKCANCEL or MB_ICONQUESTION or MB_DEFBUTTON2

OHook6: push    eax
        INVOKE  UnhookWindowsHookEx,hMbHook
        pop     eax
        cmp     al,6
        cmc
        sbb     al,ah
        shr     eax,1

;EAX: 0 = Overwrite, 1 = Cancel, 2 = Append

OHook7: cmp     al,1
        jz      OHook8

        pop     edi
        mov     SaveAsFlag,eax
        pop     ebx
        jmp     OHook0

OHook8: push    eax
        mov     [edi],ah
        INVOKE  SetWindowLong,ebx,DWLP_MSGRESULT,eax
        pop     eax
        pop     edi
        pop     ebx
        ret     16

OFNProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************


        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

CBTProc PROC    nCode:UINT,wParam:WPARAM,lParam:LPARAM

;hook to set Append/Overwrite/Yes MessageBox button strings

        cmp dword ptr [esp+4],HCBT_ACTIVATE    ;nCode
        jnz     CbtPr1

        push    esi
        push    IDOK
        mov     esi,[esp+16]                   ;wParam
        pop     eax
        mov     edx,offset szYes
        cmp     ah,MbHookFlag
        jnz     CbtPr0

        INVOKE  GetDlgItem,esi,IDYES
        INVOKE  SetWindowText,eax,offset szAppend
        push    IDNO
        mov     edx,offset szOverwrite
        pop     eax

CbtPr0: push    edx
        INVOKE  GetDlgItem,esi,eax
        push    eax
        CALL    SetWindowText
        pop     esi

CbtPr1: pop     edx
        push    hMbHook
        push    edx
        JMP     CallNextHookEx

CBTProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

dWinExit PROC

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;test code

        xor     eax,eax
        cmp     eax,thrd_ctrl
        jz      skip_thrd

        xchg    al,thrdend
        mov     al,ah

loop00: cmp     al,thrdended
        jnz     loop00

skip_thrd:

;## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ## ##

;ssf SavedSettingsFile <>
; szMarker         db 10 dup(?) ;'dTest.bin',0
; wFileSize        dw ?         ;120
; wWindowWidth     dw ?
; wWindowHeight    dw ?
; wFlagsTextSize   dw ?
; rgbBackColor     db 3 dup(?)
; rgbForeColor     db 3 dup(?)
; rgbCustomBack    db 48 dup(?)
; rgbCustomFore    db 48 dup(?)

;wFlagsTextSize bits:
;
;bit(s)  description
; 0-4     text size cell height - 4
;  5      maximized flag
;  6      status bar flag
;  7      shift-vertical mouse wheel flag
; 8-12    text size cell width - 4
; 13      ctrl-vertical mouse wheel flag
; 14      horizontal mouse wheel flag
; 15      shift-horizontal mouse wheel flag

        INVOKE  DeleteObject,hFont
        call    MakeIFn
        push    eax                                  ;HFree:hBlock
        mov     esi,ecx
        mov     edi,edx
        movsd                                        ;SavedSettingsFile.szMarker
        movsd
        movsw
        mov     eax,sizeof SavedSettingsFile         ;120
        stosw                                        ;SavedSettingsFile.wFilesize
        mov     eax,wr.right
        sub     eax,wr.left
        stosw                                        ;SavedSettingsFile.wWindowWidth
        mov     eax,wr.bottom
        sub     eax,wr.top
        stosw                                        ;SavedSettingsFile.wWindowHeight
        mov     eax,cg.v.CellSize
        mov     ah,byte ptr cg.h.CellSize
        sub     eax,404h
        cmp dword ptr pvs.MaxFlag,0
        jnz     IFile0

        or      eax,20h

IFile0: mov     ecx,StbState
        shl     ecx,3
        or      eax,ecx
        mov     ecx,ShftVrtState
        shl     ecx,4
        or      eax,ecx
        mov     ecx,CtrlVrtState
        shl     ecx,10
        or      eax,ecx
        mov     ecx,HrzState
        shl     ecx,11
        or      eax,ecx
        mov     ecx,ShftHrzState
        shl     ecx,12
        or      eax,ecx
        stosw                                        ;SavedSettingsFile.wFlagsTextSize
        mov     eax,vs.BackColor
        stosd                                        ;SavedSettingsFile.rgbBackColor
        dec     edi
        mov     eax,vs.ForeColor
        stosd                                        ;SavedSettingsFile.rgbForeColor
        push    32
        dec     edi
        mov     esi,offset cc                        ;custom color structure
        pop     ecx

IFile1: movsd                                        ;SavedSettingsFile.rgbCustomBack, rgbCustomFore
        dec     edi
        loop    IFile1

        mov     esi,offset ssf
        mov     edi,edx
        or      ecx,sizeof SavedSettingsFile/4
        repz    cmpsd
        jz      IFile2

        pop     eax
        mov     edi,edx
        push    eax
        INVOKE  OpnFile,eax,OPF_FILECREATE
        inc     eax
        jz      IFile2

        dec     eax
        push    eax                                  ;CloseHandle:hObject
        push    eax
        mov     edx,esp
        INVOKE  WriteFile,eax,edi,sizeof SavedSettingsFile,edx,NULL
        pop     ecx
        CALL    CloseHandle

IFile2: CALL    HFree
        ret

dWinExit ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

B2Hex   PROC    dwVal:UINT,lpBuf:LPSTR

;Binary Dword to Hexidecimal Zero-Terminated String

;  Returns: EAX = 0
;           ECX = 0
;           EDX = lpBuf

        push    8
        mov     edx,[esp+12]             ;lpBuf
        pop     ecx
        mov     eax,[esp+4]              ;dwVal
        mov     [edx+ecx],ch
        dec     edx

B2Hex0: push    eax
        and     al,0Fh
        cmp     al,0Ah
        sbb     al,69h
        das                              ;0-9 > '0'-'9', 10-15 > 'A'-'F'
        mov     [edx+ecx],al
        pop     eax
        shr     eax,4
        dec     ecx
        jnz     B2Hex0

        inc     edx
        ret     8

B2Hex   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

wmCreate PROC

;EDX = hWnd

;create text and control windows

        push    6
        mov     ebx,edx                                                     ;EBX = hWnd
        xor     edi,edi                                                     ;EDI = 0
        mov     eax,CID_STATUSBAR                                           ;EAX = control ID
        and     pvs.MaxFlag,ebx
        pop     ecx                                                         ;ECX = loop count
        mov     esi,offset WinCreateTable                                   ;ESI = table pointer
        mov     hWin,ebx
        mov     edx,offset chs                                              ;EDX = handle pointer

CrWin0: push    eax
        push    ecx
        push    edx
        push    edi                                                         ;CreateWindowEx:lpParam
        push    phs.hInstance                                               ;CreateWindowEx:hInstance
        push    eax                                                         ;CreateWindowEx:hMenu (control ID)
        push    ebx                                                         ;CreateWindowEx:hWndParent
        push    edi                                                         ;CreateWindowEx:nHeight
        lodsd
        push    edi                                                         ;CreateWindowEx:nWidth
        push    edi                                                         ;CreateWindowEx:y
        push    edi                                                         ;CreateWindowEx:x
        push    eax                                                         ;CreateWindowEx:dwStyle
        lodsd
        push    edi                                                         ;CreateWindowEx:lpWindowName
        push    eax                                                         ;CreateWindowEx:lpClassName
        push    edi                                                         ;CreateWindowEx:dwExStyle
        CALL    CreateWindowEx
        pop     edx
        pop     ecx
        mov     [edx],eax                                                   ;store the handle
        pop     eax
        add     edx,4                                                       ;point to next handle
        shl     al,1                                                        ;next control ID
        loop    CrWin0

;----------------------

;initialize status bar size and position values

        call    StMet
        push    edx
        push    ecx
        INVOKE  ScreenToClient,ebx,esp
        pop     StbWidth
        pop     StbPosY
        ret

wmCreate ENDP

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

DeRef   PROC    lpStart:LPVOID,lpStop:LPVOID,lpExclusions:LPVOID

;Dereference IAT Branches
;DednDave - 7, 2011
;
;  Dereferences all branches into the IAT, starting at lpStart, and ending at lpStop.
;If lpStop is NULL, the beginning of the IAT is used as the stop address.
;An exclusion list may be used to exclude specific addresses from conversion.
;Addresses in the list represent the address of the first instruction byte.
;If present, the list must be terminated with a NULL dword.
;No exclusion list is used if the lpExclusions parameter is NULL.
;
;  This version allows for the conversion of JMP's, CALL's and conditional branches.
;It will convert declspec JMP's and CALL's, including those into the MSVCRT, etc.
;
;  The converted instructions always result in a relative branch directly to the imported code.
;This will prevent hooking into the IAT, which may be overridden by hooking prior to DeRef
;execution or by use of the exclusion list.
;
;----------------------------------------------------
;
;[EBP+28] = lpExclusions
;[EBP+24] = lpStop
;[EBP+20] = lpStart
;[EBP-4]  = address of IAT start
;[EBP-8]  = address of IAT end
;[EBP-12] = adjusted lpStop (lpStop-4)
;[EBP-16] = original access protection value
;[EBP-20] = dereference count
;
;----------------------------------------------------

        push    ebx
        push    esi
        push    edi
        push    ebp
        push    6
        xor     edx,edx
        pop     ebx
        mov     esi,VirtualProtect
        mov     ebp,esp
        mov     eax,25FFh
        push    esi
        jmp short DeRef1

DeRef0: mov     edx,esi
        sub     esi,ebx

DeRef1: cmp     ax,[esi]
        jz      DeRef0

        pop     esi
        or      edx,edx
        push    edx                        ;[EBP-4] = address of IAT start
        jz      DeRefL

DeRef2: mov     ecx,esi
        add     esi,ebx
        cmp     ax,[esi]
        jz      DeRef2

        mov     edi,[ebp+24]               ;lpStop
        add     ecx,2
        or      edi,edi
        push    ecx                        ;[EBP-8] = address of IAT end
        jnz     DeRef3

        mov     edi,edx

DeRef3: mov     edx,edi
        mov     esi,[ebp+20]               ;lpStart
        sub     edx,4
        sub     edi,esi
        push    edx                        ;[EBP-12] = adjusted lpStop (lpStop-4)
        mov     [ebp+24],edi               ;[EBP+24] is now code stream length
        push    eax                        ;[EBP-16] = previous access protection value
        INVOKE  VirtualProtect,esi,edi,PAGE_EXECUTE_READWRITE,esp
        or      eax,eax
        push    0                          ;[EBP-20] = dereference count
        jnz     DeRefH

        jmp     DeRefL

DeRef4: xor     ecx,ecx
        cmp     al,0E8h                    ;CALL relative (to JMP indirect)
        mov     edx,ecx
        jz      DeRef5

        cmp     al,0E9h                    ;JMP relative (to JMP indirect)
        jz      DeRef6

        inc     ecx
        cmp     ax,15FFh                   ;CALL indirect (declspec)
        mov     edx,ecx
        jz      DeRef6

        cmp     ax,25FFh                   ;JMP indirect (declspec)
        jz      DeRef6

        dec     edx
        cmp     al,0Fh                     ;relative conditional branch candidate
        jnz     DeRefI

        cmp     ah,80h                     ;relative conditional branch candidate
        jb      DeRefI

        cmp     ah,8Fh                     ;relative conditional branch (to JMP indirect)
        jbe     DeRef6

        jmp     DeRefI

DeRef5: cmp     esi,offset DeRefL-4
        jz      DeRefI

DeRef6: mov     edi,esi
        add     edi,ecx
        cmp     edi,[ebp-12]               ;adjusted lpStop (lpStop-4)
        ja      DeRefK

        or      edx,edx
        mov     ebx,[edi]
        jz      DeRef9

        push    esi
        mov     esi,[ebp-4]                ;address of IAT start
        add     esi,2

DeRef7: cmp     ebx,[esi]
        jnz     DeRef8

        pop     esi
        jmp short DeRefA

DeRef8: add     esi,6
        cmp     esi,[ebp-8]                ;address of IAT end
        jbe     DeRef7

        pop     esi
        jmp     DeRefI

DeRef9: add     ebx,edi
        add     ebx,4
        cmp     ebx,[ebp-4]                ;address of IAT start
        jb      DeRefI

        cmp     ebx,[ebp-8]                ;address of IAT end
        ja      DeRefI

        push    ebx
        push    eax
        push    edx
        sub     ebx,[ebp-4]                ;address of IAT start
        mov     eax,0AAAAAAABh
        push    ebx
        mul     ebx
        shr     edx,2
        mov     eax,6
        mul     edx
        pop     ebx
        cmp     eax,ebx
        pop     edx
        pop     eax
        pop     ebx
        jnz     DeRefI

DeRefA: mov     ecx,[ebp+28]               ;lpExclusions
        or      ecx,ecx
        jz      DeRefD

        push    eax
        dec     esi
        jmp short DeRefC

DeRefB: add     ecx,4
        cmp     eax,esi
        jnz     DeRefC

        inc     esi
        pop     eax
        jmp short DeRefI

DeRefC: mov     eax,[ecx]
        or      eax,eax
        jnz     DeRefB

        inc     esi
        pop     eax

DeRefD: or      edx,edx
        jz      DeRefF

        cmp     ah,15h
        mov     ebx,[ebx]
        mov     ax,0E890h
        jz      DeRefE

        inc     ah

DeRefE: mov     [esi-1],ax
        jmp short DeRefG

DeRefF: mov     ecx,[ebx+2]
        mov     ebx,[ecx]

DeRefG: sub     ebx,edi
        sub     ebx,4
        mov     [edi],ebx
        inc dword ptr [ebp-20]             ;dereference count
        add     edi,4
        mov     esi,edi

DeRefH: mov     ax,[esi]
        inc     esi
        jmp short DeRefJ

DeRefI: inc     esi
        mov     al,ah
        mov     ah,[esi]

DeRefJ: cmp     esi,[ebp-12]               ;adjusted lpStop (lpStop-4)
        jbe     DeRef4

DeRefK: lea     edx,[ebp-12]
        INVOKE  VirtualProtect,[ebp+20],[ebp+24],[ebp-16],edx

DeRefL: pop     eax                        ;return dereference count
        leave
        pop     edi
        pop     esi
        pop     ebx
        ret     12

DeRef   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

EnumFntCB PROC  lpLogFont:DWORD,lpMetric:DWORD,fType:DWORD,lParam:DWORD

;font enumeration callback routine

        mov     edx,FeCount                     ;FeCount is a pointer for now
        cmp     edx,offset FeList+2*FELISTLENGTH
        jae     EnFCB3                          ;skip if buffer is full

        mov     ecx,[esp+4]                     ;ECX = LOGFONT structure ptr
        mov     eax,[ecx]                       ;AL = cell height
        cmp     eax,35
        ja      EnFCB3                          ;skip if height is greater than 35 pixels

        cmp dword ptr [ecx+4],35
        ja      EnFCB3                          ;skip if width is greater than 35 pixels

        mov     ah,[ecx+4]                      ;AH = cell width
        cmp     al,ah
        jb      EnFCB3                          ;skip if height is less than width

        cmp     ah,4
        jb      EnFCB3                          ;skip if width is less than 4 pixels

;skip if already in the list

        push    edx

EnFCB0: dec     edx
        dec     edx
        cmp     edx,offset FeList
        jb      EnFCB2

EnFCB1: cmp     ax,[edx]
        jnz     EnFCB0

EnFCB2: pop     edx
        jz      EnFCB3

        mov     [edx],ax
        inc     edx
        inc     edx
        mov     FeCount,edx

EnFCB3: ret     16

EnumFntCB ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;*************************************************************************************************************

RegTwo  PROC

;register 2 window classes

;WNDCLASSEX STRUCT
; cbSize           dd ?
; style            dd ?
; lpfnWndProc      dd ?
; cbClsExtra       dd ?
; cbWndExtra       dd ?
; hInstance        dd ?
; hIcon            dd ?
; hCursor          dd ?
; hbrBackground    dd ?
; lpszMenuName     dd ?
; lpszClassName    dd ?
; hIconSm          dd ?

;EDI = 0

        INVOKE  CreateSolidBrush,vs.BackColor
        mov     edx,phs.hIcon
        mov     ecx,TxtProc
        push    edx
        mov     esi,offset TxtClass
        call    RegOne
        mov     eax,COLOR_SCROLLBAR+1
        pop     edx
        mov     esi,offset WndClass
        mov     ecx,WndProc

RegOne: push    edx                                          ;hIconSm
        push    esi                                          ;lpszClassName
        push    edi                                          ;lpszMenuName
        push    eax                                          ;hbrBackground
        push    phs.hCursor                                  ;hCursor
        push    edx                                          ;hIcon
        push    phs.hInstance                                ;hInstance
        push    edi                                          ;cbWndExtra
        push    edi                                          ;cbClsExtra
        push    ecx                                          ;lpfnWndProc
        push    edi                                          ;style
        push    sizeof WNDCLASSEX                            ;cbSize
        INVOKE  RegisterClassEx,esp
        add     esp,sizeof WNDCLASSEX
        ret

RegTwo  ENDP

;*************************************************************************************************************

_main   PROC

;initialization code

;*********************************************************
;dereference IAT branches
;*********************************************************

        xor     edi,edi
;        INVOKE  DeRef,TxtProc,UsrThrd,edi

;*********************************************************
;ICC, hInstance, hIcon, hCursor, command line
;*********************************************************

        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        or      eax,eax
        pop     edx
        jnz     Start1

        mov     esi,offset IccErrText

Start0: INVOKE  MessageBox,edi,esi,ams.AppNamePtr,MB_ICONERROR
        INVOKE  ExitProcess,esi

Start1: mov     eax,offset cg
        xchg    eax,edi
        mov     cl,(pvs-cg)/4
        mov     ebx,edi
        rep     stosd
        dec     eax
        mov     cl,(pvs.WinStates-pvs)/4
        rep     stosd
        neg     eax
        stosd                                                ;pvs.WinStates = 1
        mov     [ebx].CoordinateGroup.h.CellsUsed,eax
        stosd                                                ;pvs.SeqFlush = 1
        mov     [ebx].CoordinateGroup.v.CellsUsed,eax
        mov     al,3                                         ;default wheel divisor = 3
        mov     [ebx].CoordinateGroup.h.WheelDiv,eax
        mov     [ebx].CoordinateGroup.v.WheelDiv,eax
        mov     al,SIF_RANGE or SIF_PAGE or SIF_POS
        mov     [ebx].CoordinateGroup.h.s.fMask,eax
        mov     [ebx].CoordinateGroup.v.s.fMask,eax
        mov     al,sizeof SCROLLINFO
        mov     [ebx].CoordinateGroup.h.s.cbSize,eax
        mov     [ebx].CoordinateGroup.v.s.cbSize,eax
        xor     edi,edi
        mov byte ptr [ebx].CoordinateGroup.h.CellSize,8      ;default cell width
        mov byte ptr [ebx].CoordinateGroup.v.CellSize,12     ;default cell height
        INVOKE  GetModuleHandle,edi
        mov     phs.hInstance,eax
        INVOKE  LoadIcon,eax,IDI_ICON
        mov     phs.hIcon,eax
        INVOKE  LoadCursor,edi,IDC_ARROW
        mov     phs.hCursor,eax
        INVOKE  GetCommandLine
        mov     ecx,edi
        mov     dx,2220h                                     ;double quote and space
        mov     lpCmndLineFull,eax

Start2: cmp     cl,dh                                        ;double quote
        jnz     Start4

Start3: mov     cl,[eax]
        jecxz   Start6

        inc     eax
        cmp     cl,dh                                        ;double quote
        jnz     Start3

Start4: mov     cl,[eax]
        jecxz   Start6

        inc     eax
        cmp     cl,dl                                        ;space
        jnz     Start2

Start5: mov     cl,[eax]
        inc     eax
        cmp     cl,dl                                        ;space
        jz      Start5

        dec     eax

Start6: mov     lpCmndLine,eax

;parse the command line for 3 valid ASCII hexadecimal parms

        push    3
        pop     ecx
        mov     ebp,esp

Start7: push    ecx
        mov     ebx,edi
        mov     cl,8

Start8: movzx   edx,byte ptr [eax]
        sub     dl,30h
        cmp     dl,9
        jbe     StartA

        sub     dl,7
        cmp     dl,0Fh
        jbe     StartA

Start9: mov     esp,ebp
        jmp short Valid0

StartA: shl     ebx,4
        or      ebx,edx
        inc     eax
        loop    Start8

        test byte ptr [eax],0DFh
        pop     ecx
        jnz     Start9

        inc     eax
        push    ebx
        loop    Start7

        pop     edx
        pop     ecx
        pop     eax
        or      eax,eax
        jz      Valid0

        mov     edi,offset ams
        mov     dbi.BufferRows,edx
        lea     esi,[edi].AppModeStruct.nPmaBaseCmd
        mov     dbi.BufferColumns,ecx
        stosd
        movsd
        movsd
        movsd
        movsd
        xor     edi,edi

;*********************************************************
;validate text buffer dimensions and set constants
;*********************************************************

;EDI = 0

Valid0: mov     ebx,offset dbi
        mov     eax,[ebx].DisplayBufferInfo.BufferColumns
        mov     edx,256                                      ;max columns
        or      eax,eax
        jnz     Valid1

        mov     eax,BUFFER_COLUMNS

Valid1: cmp     eax,edx
        jbe     Valid2

        xchg    eax,edx

Valid2: mov     [ebx].DisplayBufferInfo.BufferColumns,eax
        mov     edx,eax
        add     edx,5
        shl     eax,3
        and     edx,-4
        add     eax,WINDOW_WIDTH_ADDEND
        mov     [ebx].DisplayBufferInfo.RowLength,edx        ;(BufferColumns+5) AND 0FFFFFFFCh
        mov     vs.WndWidth,eax
        mov     ecx,edx
        mov     eax,[ebx].DisplayBufferInfo.BufferRows
        shr     ecx,2
        or      eax,eax
        mov     [ebx].DisplayBufferInfo.BufCalc1,ecx         ;RowLength/4
        jnz     Valid3

        mov     eax,BUFFER_ROWS

Valid3: cmp     eax,1024                                     ;max rows
        jbe     Valid4

        mov     eax,1024

Valid4: mov     [ebx].DisplayBufferInfo.BufferRows,eax
        dec     eax
        mov     [ebx].DisplayBufferInfo.BufCalc2,eax         ;BufferRows-1
        imul    eax,ecx
        add     ecx,eax
        mov     [ebx].DisplayBufferInfo.BufCalc3,eax         ;RowLength*(BufferRows-1)/4
        mov     [ebx].DisplayBufferInfo.BufCalc4,ecx         ;RowLength*BufferRows/4
        inc     ecx
        shl     eax,2
        push    edx
        shl     ecx,2
        push    eax
        push    ecx

;*********************************************************
;allocate display text buffer memory
;*********************************************************

        INVOKE  GetProcessHeap
        pop     edx
        mov     [ebx].DisplayBufferInfo.hHeap,eax
        INVOKE  HeapAlloc,eax,HEAP_ZERO_MEMORY,edx
        or      eax,eax
        jnz     aHeap0

        mov     esi,offset AllocErrText
        jmp     Start0

aHeap0: mov     [ebx].DisplayBufferInfo.hDisplayBuf,eax
        pop     edx
        add     eax,3
        and     eax,-4
        pop     ecx
        add     edx,eax
        add     ecx,eax
        mov     [ebx].DisplayBufferInfo.LastRowAddr,edx
        mov     [ebx].DisplayBufferInfo.SecondRowAddr,ecx
        mov     [ebx].DisplayBufferInfo.lpDisplayBuf,eax

;*********************************************************
;read saved view settings
;*********************************************************

        mov     ebp,edi                                      ;EBP = 0
        call    MakeIFn
        push    eax                                          ;HFree:hBlock
        push    eax
        mov     edi,ecx
        push    ebp
        push    ebp
        sub     esp,sizeof WIN32_FILE_ATTRIBUTE_DATA-8
        mov     ebx,ebp                                      ;EBX = 0
        INVOKE  GetFileAttributesEx,eax,ebp,esp
        add     esp,sizeof WIN32_FILE_ATTRIBUTE_DATA-8
        pop     edx
        pop     eax
        mov     esi,offset ssf                               ;ESI = SavedSettingsFile address
        cmp     eax,sizeof SavedSettingsFile
        pop     ecx
        jnz     RFile0

        or      edx,edx
        jnz     RFile0

        INVOKE  OpnFile,ecx,OPF_FILEREAD
        inc     eax
        jz      RFile0

        dec     eax
        push    ebp
        xchg    eax,ebx
        mov     edx,esp
        INVOKE  ReadFile,ebx,esi,sizeof SavedSettingsFile,edx,ebp
        or      eax,eax
        pop     edx
        jz      RFile0

        cmp     edx,sizeof SavedSettingsFile                 ;120
        jnz     RFile0

        push    sizeof SavedSettingsFile.szMarker            ;10
        pop     ecx
        push    esi
        repz    cmpsb
        movzx   eax,word ptr [esi]
        pop     esi
        jnz     RFile0

        cmp     eax,edx
        jz      RFile1

RFile0: mov     [esi],ebp
        mov     edi,offset cc                                ;custom color structure
        call    CcRst
        call    CcRst
        jmp     RFile3

RFile1: add     esi,12
        mov     edi,offset vs                                ;ViewSettings structure
        lodsw                                                ;ssf.wWindowWidth
        push    MF_CHECKED
        stosd                                                ;vs.WndWidth
        lodsw                                                ;ssf.wWindowHeight
        pop     ecx
        stosd                                                ;vs.WndHeight
        lodsw                                                ;ssf.wFlagsTextSize
        mov     ebp,eax
        shr     ebp,4
        and     ebp,2                                        ;EBP = show state
        mov     edx,eax
        shr     edx,3
        and     edx,ecx
        mov     StbState,edx
        mov     edx,eax
        shr     edx,4
        and     edx,ecx
        mov     ShftVrtState,edx
        mov     edx,eax
        shr     edx,10
        and     edx,ecx
        mov     CtrlVrtState,edx
        mov     edx,eax
        shr     edx,11
        and     edx,ecx
        mov     HrzState,edx
        mov     edx,eax
        shr     edx,12
        and     edx,ecx
        mov     ShftHrzState,edx
        and     eax,1F1Fh
        add     eax,404h
        mov     edx,0FFFFFFh
        stosd                                                ;vs.DefaultTextSize
        lodsd                                                ;ssf.rgbBackColor
        dec     esi
        and     eax,edx
        stosd                                                ;vs.BackColor
        lodsd                                                ;ssf.rgbForeColor
        dec     esi
        and     eax,edx
        stosd                                                ;vs.ForeColor
        push    32
        mov     edi,offset cc                                ;custom color structure
        pop     ecx

RFile2: lodsd
        dec     esi
        and     eax,edx
        stosd
        loop    RFile2

RFile3: or      ebx,ebx
        jz      RFile4

        INVOKE  CloseHandle,ebx

RFile4: inc     ebp                                          ;SW_SHOWNORMAL EQU 1, SW_SHOWMAXIMIZED EQU 3
        CALL    HFree
        push    ebp                                          ;main window show state on stack

;*********************************************************
;get system metrics and justify main window size
;*********************************************************

        call    ScMet                                        ;scrollbar metrics
        call    WkMet                                        ;working screen size metrics
        mov     ecx,offset vs
        xor     edi,edi
        cmp     edx,[ecx].ViewSettings.WndWidth
        jae     IMetr0

        mov     [ecx].ViewSettings.WndWidth,edx

IMetr0: cmp     eax,[ecx].ViewSettings.WndHeight
        jae     FEnum0

        mov     [ecx].ViewSettings.WndHeight,eax

;*********************************************************
;enumerate "Terminal" font sizes
;*********************************************************

FEnum0: INVOKE  GetDC,edi
        mov     edx,offset lf
        push    eax                                          ;ReleaseDC:hDC
        mov dword ptr [edx].LOGFONT.lfFaceName,6D726554h     ;'Term'
        mov dword ptr [edx].LOGFONT.lfFaceName+4,6C616E69h   ;'inal'
        mov byte ptr [edx].LOGFONT.lfCharSet,OEM_CHARSET     ;EQU 255
        INVOKE  EnumFontFamiliesEx,eax,edx,EnumFntCB,edi,edi
        push    edi                                          ;ReleaseDC:hWnd
        CALL    ReleaseDC

;*********************************************************
;create main menu
;*********************************************************

        INVOKE  CreateMenu
        mov     hMenu,eax
        mov     esi,offset MenuTable
        or      edi,MAIN_MENU_ITEMS                          ;4
        xchg    eax,ebx                                      ;EBX = hMenu

MMenu0: INVOKE  CreatePopupMenu
        push    eax
        lodsd
        xchg    eax,ebp

MMenu1: pop     edx
        lodsd
        push    edx
        push    eax
        lodsd
        push    eax
        lodsd
        push    eax
        push    edx
        CALL    AppendMenu
        dec     ebp
        jnz     MMenu1

        pop     edx
        lodsd
        push    edx
        INVOKE  AppendMenu,ebx,MF_POPUP,edx,eax
        dec     edi
        jnz     MMenu0

        pop     ecx                                          ;discard Help menu handle
        pop     ebp                                          ;EBP = View menu handle
        pop     hEditMenu                                    ;store Edit menu handle
        pop     edx                                          ;discard File menu handle
        or      edi,2

MMenu2: INVOKE  CreatePopupMenu
        xchg    eax,edx
        lodsd
        xchg    eax,ecx

MMenu3: push    edx
        lodsd
        push    ecx
        push    eax
        lodsd
        push    eax
        lodsd
        push    eax
        push    edx
        CALL    AppendMenu
        pop     ecx
        pop     edx
        loop    MMenu3

        or      ecx,3
        sub     ecx,edi
        lodsd
        shl     ecx,1
        INVOKE  InsertMenu,ebp,ecx,MF_BYPOSITION or MF_POPUP,edx,eax
        dec     edi
        jnz     MMenu2

;----------------------

;calculate the text size list length
;the length must be greater than 1 to make a text size menu ;)

        mov     ecx,FeCount
        mov     edx,offset FeList
        sub     ecx,edx
        shr     ecx,1
        mov     FeCount,ecx
        jz      MMenuF                                       ;use default if 0

        dec     ecx
        jnz     MMenu4

        mov     edx,IDM_TEXT_SIZE
        call    FontSize
        jmp     MMenuF

;----------------------

;sort the text size list

;EBX = hMenu
;ECX = text size list length
;EDX = offset FeList
;EBP = View menu handle
;EDI = 0

MMenu4: push    ebx
        push    ebp

MMenu5: push    edx
        movzx   eax,word ptr [edx]
        push    ecx

MMenu6: push    ecx
        movzx   ecx,word ptr [edx+2]
        cmp     eax,ecx
        ja      MMenu7

        xchg    eax,ecx
        jmp short MMenu8

MMenu7: mov     [edx],cx
        mov     [edx+2],ax

MMenu8: pop     ecx
        inc     edx
        inc     edx
        loop    MMenu6

        pop     ecx
        pop     edx
        loop    MMenu5

;----------------------

;create text size popup menu

;EDX = offset FeList

        push    edx
        INVOKE  CreatePopupMenu
        pop     edx
        mov     bx,3030h
        mov     esi,IDM_TEXT_SIZE
        xchg    eax,ebp
        push    edx
        push    ecx
        push    eax
        mov     ecx,FeCount
        mov     edi,esp

MMenu9: movzx   eax,word ptr [edx]
        push    edi
        push    eax
        mov     al,ah
        aam
        or      eax,ebx
        cmp     ah,bl
        jz      MMenuA

        mov     [edi],ah
        inc     edi

MMenuA: mov     ah,'x'
        stosw
        pop     eax
        aam
        or      eax,ebx
        cmp     ah,bl
        jz      MMenuB

        mov     [edi],ah
        inc     edi

MMenuB: mov     ah,0
        inc     edx
        stosw
        inc     edx
        pop     edi
        push    edx
        push    ecx
        INVOKE  AppendMenu,ebp,MF_STRING,esi,edi
        pop     ecx
        inc     esi
        pop     edx
        inc     esi
        loop    MMenu9

        pop     ebx
        pop     eax
        pop     ebx
        pop     eax
        INVOKE  InsertMenu,eax,ecx,MF_BYPOSITION or MF_POPUP,ebp,offset szTextSize

;----------------------

;select the default text size

;EBX = offset FeList

        mov     eax,FeCount
        or      esi,-1
        mov     edi,eax
        shl     eax,1
        add     eax,IDM_TEXT_SIZE
        mov     ecx,vs.DefaultTextSize
        mov     FeCount,eax

MMenuC: movzx   eax,word ptr [ebx]
        sub     eax,ecx
        jnc     MMenuD

        neg     eax

MMenuD: cmp     eax,esi
        ja      MMenuE

        mov     edx,ebx
        xchg    eax,esi

MMenuE: inc     ebx
        inc     ebx
        dec     edi
        jnz     MMenuC

;----------------------

;implement the selected text size

        sub     edx,offset FeList-IDM_TEXT_SIZE
        call    SelectSize
        pop     ebx

;----------------------

;create a handle for the selected text size

MMenuF: call    MakeFont
        call    TextCalc

;*********************************************************
;register window classes
;*********************************************************

        call    RegTwo
        pop     ebp                                          ;EBP = main window show state

;EBX = hMenu
;EBP = main window initial show state (SW_SHOWNORMAL / SW_SHOWMAXIMIZED)
;ESI = offset WndClass
;EDI = 0

;----------------------

;static test code

        IF      dTest_TESTMODE_STATIC

        call    StaticTest

        ENDIF

;----------------------

;create and update the main window

        INVOKE  CreateWindowEx,edi,esi,ams.AppNamePtr,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,ebp,vs.WndWidth,vs.WndHeight,edi,ebx,phs.hInstance,edi
        push    eax                                ;UpdateWindow:hWnd
        CALL    UpdateWindow

;----------------------

;dynamic test code

        IF      dTest_TESTMODE_DYNAMIC

        INVOKE  CreateThrd,4096,DynamicTest,edi

        ENDIF

;----------------------

;

        cmp     edi,ams.hRcvr
        mov byte ptr rvs.sUpdateEnable,-1
        mov byte ptr rvs.dUpdateMode,DMODE_FULL_AUTO
        jnz     main00

        INVOKE  CreateThrd,edi,UsrThrd,edi
        jmp short main01

main00: INVOKE  SndAck,edi

call TextReady

main01: pushad                                     ;create stack space for MSG structure
        mov     ebp,esp

mov byte ptr cBuffEnable,1

        jmp     mLoop

_main   ENDP

;*************************************************************************************************************

IF dTest_BUILD_DUALMODE

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

OpnPres PROC    uBufferColumns:UINT,uBufferRows:UINT

;execute the presentation manager app

        push    edi
        push    ebx
        xor     edi,edi
        push    esi
        cmp     edi,ams.hRcvr
        jnz     OPres1

        INVOKE  Sleep,250

;'dTest.exe 12345678 12345678 12345678',0

        call    GetExeFile
        xchg    eax,esi
        mov     bl,20h
        add     ecx,esi
        mov     [ecx],bl
        inc     ecx
        INVOKE  B2Hex,hWin,ecx                      ;pass hWin
        add     edx,8
        mov     [edx],bl
        inc     edx
        INVOKE  B2Hex,[esp+20],edx                  ;pass uBufferColumns
        add     edx,8
        mov     [edx],bl
        inc     edx
        INVOKE  B2Hex,[esp+24],edx                  ;pass uBufferRows

;PROCESS_INFORMATION STRUCT
; hProcess             dd ?
; hThread              dd ?
; dwProcessId          dd ?
; dwThreadId           dd ?

;STARTUPINFO         STRUCT
; cb                   dd ?
; lpReserved           dd ?
; lpDesktop            dd ?
; lpTitle              dd ?
; dwX                  dd ?
; dwY                  dd ?
; dwXSize              dd ?
; dwYSize              dd ?
; dwXCountChars        dd ?
; dwYCountChars        dd ?
; dwFillAttribute      dd ?
; dwFlags              dd ?
; wShowWindow          dw ?
; cbReserved2          dw ?
; lpReserved2          dd ?
; hStdInput            dd ?
; hStdOutput           dd ?
; hStdError            dd ?

        push    (sizeof STARTUPINFO-4)/4
        pop     ecx
        sub     esp,sizeof STARTUPINFO+sizeof PROCESS_INFORMATION-4
        xor     eax,eax
        mov     edi,esp
        rep     stosd
        push    sizeof STARTUPINFO
        xchg    eax,edi
        mov     edx,esp
        INVOKE  CreateProcess,edi,esi,edi,edi,edi,
                CREATE_NEW_PROCESS_GROUP or NORMAL_PRIORITY_CLASS,
                edi,edi,edx,eax
        push    eax
        INVOKE  HFree,esi
        pop     eax
        add     esp,sizeof STARTUPINFO+sizeof PROCESS_INFORMATION
        or      eax,eax
        jz      OPres2

        push    100
        pop     esi                                 ;timeout count = 100 (x 100 mS = 10 seconds)
        mov     ebx,esi                             ;timeout interval = 100 mS

OPres0: INVOKE  Sleep,ebx
        dec     esi
        jz      OPres2

        cmp     edi,ams.hRcvr
        jz      OPres0

OPres1: pop     esi
        pop     ebx
        pop     edi
        ret     8

OPres2: INVOKE  MessageBox,hWin,offset PmaErrText,ams.AppNamePtr,MB_ICONERROR
        INVOKE  DeleteObject,hFont
        INVOKE  HFree,dbi.hDisplayBuf
        INVOKE  ExitProcess,edi

OpnPres ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

ENDIF

;*************************************************************************************************************

UsrThrd PROC

;only started if ams.hRcvr = 0

        call    UsrCode
        INVOKE  ExitThread,0

UsrThrd ENDP

;*************************************************************************************************************

        INCLUDE UserCode.inc

IFNDEF UsrCode

UsrCode PROC

        ret

UsrCode ENDP

ENDIF

;#############################################################################################################

;test code section

;#############################################################################################################

IF dTest_TESTMODE_STATIC

StaticTest  PROC

;test code - fill the buffer with static text

        push    dbi.BufferColumns
        mov     edx,dbi.lpDisplayBuf
        mov     ecx,dbi.BufferRows
        pop     cg.h.CellsUsed
        push    edx
        mov     cg.v.CellsUsed,ecx
        mov     al,'0'
        push    ecx

tFill0: push    ecx
        push    edx
        push    eax
        mov     ecx,dbi.BufferColumns
        mov     [edx],cx
        inc     edx
        inc     edx

tFill1: mov     [edx],al
        inc     eax
        cmp     al,'z'
        jbe     tFill2

        mov     al,'0'

tFill2: inc     edx
        loop    tFill1

        pop     eax
        pop     edx
        pop     ecx
        inc     eax
        cmp     al,'z'
        jbe     tFill3

        mov     al,'0'

tFill3: add     edx,dbi.RowLength
        loop    tFill0

;----------------------

;last char = 219 if more than 1 column and row

        mov     eax,dbi.BufferColumns
        mov     ecx,dbi.RowLength
        add     edx,eax
        cmp     eax,1
        pop     eax                      ;EAX = dbi.BufferRows
        ja      tFillX

        cmp     eax,1
        jbe     tFillY

tFillX: inc     edx
        sub     edx,ecx
        mov byte ptr [edx],219

;----------------------

;one line with spaces on the right

tFillY: shr     eax,1
        dec     eax
        mul     ecx
        pop     edx                      ;EDX = dbi.lpDisplayBuf
        push    ecx
        add     edx,eax
        movzx   ecx,word ptr [edx]
        mov     eax,ecx
        shr     eax,1
        mov     [edx],ax
        inc     edx
        inc     edx
        push    edx
        push    eax
        sub     ecx,eax
        add     edx,eax
        mov     al,20h

tFill4: mov     [edx],al
        inc     edx
        loop    tFill4

;----------------------

;one line with spaces on the left

        pop     ecx
        pop     edx
        pop     eax
        add     edx,eax
        mov     al,20h

tFill5: mov     [edx],al
        inc     edx
        loop    tFill5

tFill6: jmp     TextCalc

StaticTest ENDP

ENDIF

;*************************************************************************************************************

IF dTest_TESTMODE_DYNAMIC

DynamicTest PROC

        mov     eax,thrd_mode
        call    ChangeMode
        INVOKE  Sleep,thrd_time2
        xor     ebx,ebx

DtThrd: INVOKE  dTxtOut,offset teststr
        INVOKE  Sleep,thrd_time1
        cmp     bl,thrdend
        jnz     DtThrd

        xchg    bl,thrdended
        INVOKE  ExitThread,ebx

DynamicTest ENDP

ENDIF

;#############################################################################################################

        END     _main

